# **********************************************************************
#
# Copyright (c) 2002
# IONA Technologies, Inc.
# Waltham, MA, USA
#
# All Rights Reserved
#
# **********************************************************************

top_srcdir	= ..

NAME		= OBBalancer.jar

!include $(top_srcdir)\..\config\Make.rules.mak

ALL_LIBS        = $(OB_LIB)

IDLDIR		= $(top_srcdir)\idl\OB

all:: generate compile

generate: $(top_srcdir)\lib generated
	$(JIDL) $(JIDLFLAGS) -I$(top_srcdir)\..\ob\idl -I$(top_srcdir)\idl \
	    --auto-package --output-dir generated \
	    BalancerInternal.idl \
	    BalancerPolicies.idl \
	    GroupORT.idl
	$(JIDL) $(JIDLFLAGS) -I$(top_srcdir)\..\ob\idl -I$(top_srcdir)\idl \
	    --auto-package --output-dir generated \
	    $(IDLDIR)\Balancer.idl \
	    $(IDLDIR)\BalancerPolicyTypes.idl \
	    $(IDLDIR)\BalancerProperties.idl \
	    $(IDLDIR)\BalancerTypes.idl \
	    $(IDLDIR)\BalancerUtil.idl

compile: $(top_srcdir)\lib generated
	set CLASSPATH=.;generated;$(top_srcdir)\lib;$(OB_LIB);$(CLASSPATH)
	    $(JAVAC) $(JAVACFLAGS) -d $(top_srcdir)\lib \
	    generated/com/ooc/LoadBalancing/*.java \
	    com/ooc/LoadBalancing/*.java \
	    com/ooc/LoadBalancing/Util/*.java

jar:
	cd $(top_srcdir)\lib
	if exist $(NAME) del $(NAME)
	$(JAR) $(JARFLAGS) $(NAME) org com

install:: jar
	copy $(top_srcdir)\lib\$(NAME) $(libdir)

clean::
	-rmdir /s /q $(top_srcdir)\lib
