// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.LoadBalancing;

//
// IDL:ooc.com/LoadBalancing/GroupORT:1.0
//

final public class GroupORT_impl extends GroupORT
{
    // -----------------------------------------------------------------
    // GroupORT_impl constructor
    // -----------------------------------------------------------------

    protected
    GroupORT_impl()
    {
    }

    protected
    GroupORT_impl(String group_id,
		  org.omg.PortableInterceptor.ObjectReferenceTemplate real_ort)
    {
	this.group_id = group_id;
	this.real_ort = real_ort;
    }

    // -----------------------------------------------------------------
    // IDL to Java Mapping
    // -----------------------------------------------------------------

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/make_object:1.0
    //
    public org.omg.CORBA.Object
    make_object(String repository_id,
                byte[] id)
    {
	if(real_ort == null)
	    return null;

	//
	// Convert the group id to bytes.
	//
	byte[] groupIdBytes = group_id.getBytes();

	//
	// Convert the repository id to bytes.
	//
	byte[] repositoryIdBytes = repository_id.getBytes();

	//
	// Combine
	//  - the group id length bytes,
	//  - the group id bytes,
	//  - the repository id length bytes,
	//  - the repository id bytes, and
	//  - the given id
	// to create the new object id.
	//
	int len = 4 + groupIdBytes.length +
		  4 + repositoryIdBytes.length +
		  id.length;
	byte[] newOid = new byte[len];

	//
	// Copy the the length of the group id bytes.
	//
	int pos = 0;
	int groupIdBytesLen = groupIdBytes.length;
	newOid[pos++] = (byte)(groupIdBytesLen >>> 24);
	newOid[pos++] = (byte)(groupIdBytesLen >>> 16);
	newOid[pos++] = (byte)(groupIdBytesLen >>> 8);
	newOid[pos++] = (byte)(groupIdBytesLen);

	//
	// Copy the group id bytes.
	//
	for(int j = 0 ; j < groupIdBytes.length ; j++)
	    newOid[pos++] = groupIdBytes[j];

	//
	// Copy the the length of the repository id bytes.
	//
	int repositoryIdByteslen = repositoryIdBytes.length;
	newOid[pos++] = (byte)(repositoryIdByteslen >>> 24);
	newOid[pos++] = (byte)(repositoryIdByteslen >>> 16);
	newOid[pos++] = (byte)(repositoryIdByteslen >>> 8);
	newOid[pos++] = (byte)(repositoryIdByteslen);

	//
	// Copy the repository id bytes.
	//
	for(int j = 0 ; j < repositoryIdBytes.length ; j++)
	    newOid[pos++] = repositoryIdBytes[j];

	//
	// Copy the given id.
	//
	for(int j = 0 ; j < id.length ; j++)
	    newOid[pos++] = id[j];

	//
	// Return the new object.
	//
	return real_ort.make_object(repository_id, newOid);
    }

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/server_id:1.0
    //
    public String
    server_id()
    {
	return real_ort.server_id();
    }

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/orb_id:1.0
    //
    public String
    orb_id()
    {
	return real_ort.orb_id();
    }

    //
    // IDL:omg.org/PortableInterceptor/ObjectReferenceTemplate/adapter_name:1.0
    //
    public String[]
    adapter_name()
    {
	return real_ort.adapter_name();
    }
}
