// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.LoadBalancing.Util;

final public class Logger
{
    //
    // The message logger
    //
    private com.ooc.OB.Logger logger_;

    //
    // The trace level
    //
    private int traceLevel_;

    // -----------------------------------------------------------------
    // Logger constructor
    // -----------------------------------------------------------------

    public Logger(com.ooc.OB.Logger logger, java.util.Properties properties)
    {
	logger_ = logger;

	String value =
	    properties.getProperty("ooc.balancer.util.trace_level");
	if(value != null)
	    traceLevel_ = Integer.parseInt(value);
    }

    // -----------------------------------------------------------------
    // public member implementation
    // -----------------------------------------------------------------

    //
    // Methods to get the trace level.
    //
    public int traceLevel()
    {
	return traceLevel_;
    }

    //
    // Methods to perform logging.
    //
    public void info(String msg)
    {
	logger_.info(msg);
    }
    public void error(String msg)
    {
	logger_.error(msg);
    }
    public void warning(String msg)
    {
	logger_.warning(msg);
    }
    public void trace(String category, String msg)
    {
	logger_.trace(category, msg);
    }
}
