// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;
import org.omg.CosEventComm.*;

class PullSupplier_impl extends PullSupplierPOA
{
    private ORB orb_; // The ORB
    private POA poa_; // My POA
    private boolean slow_; // Is this consumer slow?

    PullSupplier_impl(ORB orb, POA poa, boolean slow)
    {
	orb_ = orb;
	poa_ = poa;
	slow_ = slow;
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public void
    disconnect_pull_supplier()
    {
        byte[] oid = null;
	try
	{
            oid = poa_.servant_to_id(this);
	}
	catch(ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(WrongPolicy ex)
        {
            throw new RuntimeException();
        }                        

	try
	{
            poa_.deactivate_object(oid);
	}
	catch(ObjectNotActive ex)
        {
            throw new RuntimeException();
        }                        
	catch(WrongPolicy ex)
        {
            throw new RuntimeException();
        }                        

        orb_.shutdown(false);        
    }

    //
    // Supply date and time
    //
    public Any
    pull()
    {
	java.util.Date date = new java.util.Date();
	String s = "PullSupplier says: " + date.toString();

	Any any = orb_.create_any();
	any.insert_string(s);

	if(slow_)
	{
	    try
	    {
		Thread.sleep(2000);
	    }
	    catch(InterruptedException e)
	    {
	    }
	}

	return any;
    }

    public Any
    try_pull(BooleanHolder hasEvent)
    {
	hasEvent.value = true;
	return pull();
    }
}
