// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEvent;

import org.omg.CORBA.*;

final public class EventUtil
{
    static public String getConnectionAddrDescription(ORB orb)
    {
        org.omg.CORBA.Object obj = null;
        try
        {
	    obj = orb.resolve_initial_references("OCICurrent");
	}
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
	{
	}
	com.ooc.OB.Assert._OB_assert(obj != null);
	com.ooc.OCI.Current current = com.ooc.OCI.CurrentHelper.narrow(obj);
	com.ooc.OB.Assert._OB_assert(current != null);
	com.ooc.OCI.TransportInfo info = current.get_oci_transport_info();

	String desc;
	if(info != null)
	    desc = info.describe();
	else
	    desc = "UNKNOWN";

	return desc;
    }

    // ------------------------------------------------------------------
    // Internal functions
    // ------------------------------------------------------------------

    static int
    port(short s)
    {
	if(s < 0)
	    return 0xffff + (int)s + 1;
	else
	    return (int)s;
    }
    
    static int[]
    addr(byte[] bArray)
    {
	int[] iArray = new int[4];
	for(int i = 0 ; i < 4 ; i++)
	    if(bArray[i] < 0)
		iArray[i] = 0xff + (int)bArray[i] + 1;
	    else
		iArray[i] = (int)bArray[i];
	
	return iArray;
    }
}
