// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEvent;

import org.omg.CORBA.*;

final public class Event_impl
{
    private EventLogger logger_; // Message logger

    //
    // For typed event.
    //
    private NVList args_; // The arguments.
    private String op_; // The operation name.

    //
    // For an untyped event.
    //
    private Any any_; // The event data.

    private long id_; // My ID.

    private static long nextId_ = 0;

    private void
    init(long proxyId)
    {
        id_ = nextId_++;
	if(logger_.traceEvents() >= 2)
	    logger_.trace("event",
	                  "creating Event(" + id_ + ") from " + proxyId);
    }
    
    public Event_impl(EventLogger logger, Any any, long proxyId)
    {
        logger_ = logger;
        any_ = any;
        init(proxyId);
    }

    public Event_impl(EventLogger logger, NVList args, String op, long proxyId)
    {
        logger_ = logger;
        args_ = args;
        op_ = op;
        init(proxyId);
    }

    protected void
    finalize()
        throws Throwable
   {
	if(logger_.traceEvents() >= 2)
	    logger_.trace("event", "destroying Event(" + id_ + ")");
   }

    //
    // For any events.
    //
    public Any
    any()
    {
        return any_;
    }

    //
    // For typed events.
    //
    public String
    op()
    {
        return op_;
    }

    public NVList
    args()
    {
        return args_;
    }

    public long
    eventId()
    {
        return id_;
    }
}
