// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************
 
package com.ooc.CosEventChannelAdmin;

import com.ooc.CosEvent.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;

final class ConsumerAdmin_impl
    extends org.omg.CosEventChannelAdmin.ConsumerAdminPOA
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;

    // ------------------------------------------------------------------
    // ConsumerAdmin_impl constructor
    // ------------------------------------------------------------------

    ConsumerAdmin_impl(ORB orb, POA poa, EventLogger logger, Reaper reaper,
    		       PipeSegment pipe)
    {
	adminImpl_ = new AdminBaseImpl(orb, poa, logger, reaper, pipe, this);

	if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event", "creating ConsumerAdmin");
    }

    protected void
    finalize()
	throws Throwable
    {
        if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event", "destroying ConsumerAdmin");
    }
                  
    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushSupplier.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPushSupplier
    obtain_push_supplier()
    {
        if(adminImpl_.destroyed())
            throw new OBJECT_NOT_EXIST();

	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPushSupplier_impl p = new ProxyPushSupplier_impl(info);
        adminImpl_.addProxy(p);

	return p._this(adminImpl_.getOrb());
    }

    //
    // Get ProxyPullSupplier.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPullSupplier
    obtain_pull_supplier()
    {
        if(adminImpl_.destroyed())
            throw new OBJECT_NOT_EXIST();
        
	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPullSupplier_impl p = new ProxyPullSupplier_impl(info);
        adminImpl_.addProxy(p);

	return p._this(adminImpl_.getOrb());
    }

    public POA
    _default_POA()
    {
        return adminImpl_.getPoa();
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------
    
    public void
    deactivateObject()
    {
	POA poa = _default_POA();
	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }

    public synchronized void
    disconnect()
    {
	adminImpl_.disconnect();
    }

    public synchronized void
    discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
