// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEventChannelAdmin;

import com.ooc.CosEvent.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;

final class ProxyPullConsumer_impl
    extends org.omg.CosEventChannelAdmin.ProxyPullConsumerPOA
    implements ProxyBase
{
    //
    // The ProxyBaseImpl Object
    //
    private ProxyBaseImpl proxyImpl_;

    //
    // My pull supplier.
    //
    private org.omg.CosEventComm.PullSupplier supplier_;

    //
    // The event puller.
    //
    private PropagatorBaseThread puller_;

    // ------------------------------------------------------------------
    // ProxyPullConsumer_impl constructor
    // ------------------------------------------------------------------

    ProxyPullConsumer_impl(ProxyConstructorInfo info)
    {
	info.base = "ProxyPullConsumer";
	proxyImpl_ = new ProxyBaseImpl(info, this);
    }

    protected void
    finalize()
        throws Throwable
    {
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    synchronized public void
    connect_pull_supplier(org.omg.CosEventComm.PullSupplier supplier)
	throws org.omg.CosEventChannelAdmin.AlreadyConnected
    {
	if(proxyImpl_.getState() == ProxyState.Destroyed)
	    throw new OBJECT_NOT_EXIST();

	if(proxyImpl_.getState() == ProxyState.Discarding)
	    throw new TRANSIENT();

	if(proxyImpl_.getState() == ProxyState.Connected)
	    throw new org.omg.CosEventChannelAdmin.AlreadyConnected();

	if(supplier == null)
	    throw new BAD_PARAM();
	
	QoSParameters params = new QoSParameters();
	proxyImpl_.resolveQoSParams(params);

	supplier_ = org.omg.CosEventComm.PullSupplierHelper.narrow(
	    proxyImpl_.applyRequestTimeout(supplier, params)
	);
	
	proxyImpl_.setState(ProxyState.Connected);

	com.ooc.OB.Assert._OB_assert(puller_ == null);
	
	puller_ = new AnyPullerThread(supplier_, this._this(),
				      proxyImpl_.getId(),
				      proxyImpl_.getParentPipe(),
				      params.pullInterval, params.maxRetries,
				      params.retryTimeout,
				      params.retryMultiplier,
				      proxyImpl_.getLogger());
	puller_.start();
    }

    synchronized public void
    disconnect_pull_consumer()
    {
	if(proxyImpl_.getState() == ProxyState.Destroyed)
	    throw new OBJECT_NOT_EXIST();

	if(proxyImpl_.getState() == ProxyState.Discarding)
	    throw new TRANSIENT();

	proxyImpl_.disconnect();
    }

    public POA
    _default_POA()
    {
        return proxyImpl_.getPoa();
    }
    
    // ------------------------------------------------------------------
    // ProxyBase implementation
    // ------------------------------------------------------------------

    //
    // Disconnect the servant from the ORB
    //
    public void deactivateObject()
    {
	POA poa = _default_POA();
	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }
    
    //
    // Called during disconnect
    //
    public void disconnectPeer()
    {
	//
	// Stop the puller, if running.
	//
	if(puller_ != null)
	    puller_.halt();

	//
	// If we're connected then tell the supplier.
	//
	if(supplier_ != null)
	{
	    try
	    {
		supplier_.disconnect_pull_supplier();
	    }                                              
	    catch(SystemException e)
	    {
	    }
	    supplier_ = null;
	}
    }

    //
    // Disconnect the proxy
    //
    public synchronized void disconnect()
    {
	proxyImpl_.disconnect();
    }

    //
    // Don't accept further requests
    //
    public synchronized void discardRequests()
    {
	proxyImpl_.discardRequests();

	//
	// Stop the puller, if running.
	//
	if(puller_ != null)
	    puller_.halt();
    }

    //
    // Has this proxy been destroyed?
    //
    public synchronized boolean destroyed()
    {
	return proxyImpl_.destroyed();
    }

    //
    // Can this proxy be reaperd?
    //
    public boolean canReap()
    {
	return false;
    }

    //
    // What was the time of the last request?
    //
    public long lastRequestTime()
    {
	return proxyImpl_.lastRequestTime();
    }

    //
    // Set the time of the last request
    //
    public void stampRequest()
    {
	proxyImpl_.stampRequest();
    }

    //
    // Get the name of the proxy
    //
    public String getName()
    {
	return proxyImpl_.getName();
    }
}
