// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosEventChannelAdmin;

import com.ooc.CosEvent.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;

final class SupplierAdmin_impl
    extends org.omg.CosEventChannelAdmin.SupplierAdminPOA
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;

    // ------------------------------------------------------------------
    // SupplierAdmin_impl constructor
    // ------------------------------------------------------------------

    SupplierAdmin_impl(ORB orb, POA poa, EventLogger logger, Reaper reaper,
    		       PipeSegment pipe)
    {
	adminImpl_ = new AdminBaseImpl(orb, poa, logger, reaper, pipe, this);

	if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event", "creating SupplierAdmin");
    }

    protected void
    finalize()
	throws Throwable
    {
	if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event", "destroying SupplierAdmin");
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushConsumer.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPushConsumer
    obtain_push_consumer()
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();
	
	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPushConsumer_impl p = new ProxyPushConsumer_impl(info);
        adminImpl_.addProxy(p);

	return p._this(adminImpl_.getOrb());
    }

    //
    // Get ProxyPullConsumer.
    //
    synchronized public org.omg.CosEventChannelAdmin.ProxyPullConsumer
    obtain_pull_consumer()
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();

	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	ProxyPullConsumer_impl p = new ProxyPullConsumer_impl(info);
        adminImpl_.addProxy(p);

	return p._this(adminImpl_.getOrb());
    }

    public POA
    _default_POA()
    {
        return adminImpl_.getPoa();
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------
    
    public void
    deactivateObject()
    {
	POA poa = _default_POA();
	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }

    public synchronized void
    disconnect()
    {
	adminImpl_.disconnect();
    }

    public synchronized void
    discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
