// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTypedEventChannelAdmin;

import com.ooc.CosEvent.*;
import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import org.omg.PortableServer.POAPackage.*;

final class TypedSupplierAdmin_impl
    extends org.omg.CosTypedEventChannelAdmin.TypedSupplierAdminPOA
    implements AdminBase
{
    //
    // The AdminBaseImpl object
    //
    private AdminBaseImpl adminImpl_;

    //
    // The channel type.
    //
    private ChannelType type_;

    // ------------------------------------------------------------------
    // TypedSupplierAdmin constructor
    // ------------------------------------------------------------------

    TypedSupplierAdmin_impl(ORB orb, POA poa, EventLogger logger,
    			    Reaper reaper, PipeSegment pipe, ChannelType type)
    {
	adminImpl_ = new AdminBaseImpl(orb, poa, logger, reaper, pipe, this);
	type_ = type;

	if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event",
	    				 "creating TypedSupplierAdmin");
    }

    protected void
    finalize()
        throws Throwable
    {
	if(adminImpl_.getLogger().traceLifecycle() >= 1)
	    adminImpl_.getLogger().trace("event",
	    				 "destroying TypedSupplierAdmin");
    }

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    //
    // Get ProxyPushConsumer.
    //
    public org.omg.CosEventChannelAdmin.ProxyPushConsumer
    obtain_push_consumer()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get ProxyPullConsumer.
    //
    public org.omg.CosEventChannelAdmin.ProxyPullConsumer
    obtain_pull_consumer()
    {
	throw new NO_IMPLEMENT();
    }

    //
    // Get TypedProxyPushConsumer.
    //
    synchronized
    public org.omg.CosTypedEventChannelAdmin.TypedProxyPushConsumer
    obtain_typed_push_consumer(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.InterfaceNotSupported
    {
	if(adminImpl_.destroyed())
	    throw new OBJECT_NOT_EXIST();

	//
	// Attempt to assign this type id to the channel.
	//
	if(!type_.assignTypeId(typeId))
	    throw new org.omg.CosTypedEventChannelAdmin.
		InterfaceNotSupported();
	
	ProxyConstructorInfo info = new ProxyConstructorInfo();
	adminImpl_.fillProxyConstructorInfo(info);

	TypedProxyPushConsumer_impl p =
	    new TypedProxyPushConsumer_impl(info, type_);
        adminImpl_.addProxy(p);

	return p._this(adminImpl_.getOrb());
    }

    //
    // Get TypedProxyPullConsumer.
    //
    synchronized
    public org.omg.CosEventChannelAdmin.ProxyPullConsumer
    obtain_typed_pull_consumer(String typeId)
	throws org.omg.CosTypedEventChannelAdmin.NoSuchImplementation
    {
	throw new NO_IMPLEMENT();
    }

    public POA
    _default_POA()
    {
        return adminImpl_.getPoa();
    }

    // ------------------------------------------------------------------
    // AdminBase implementation
    // ------------------------------------------------------------------
    
    public void
    deactivateObject()
    {
	POA poa = _default_POA();
	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }

    public synchronized void
    disconnect()
    {
	adminImpl_.disconnect();
    }

    public synchronized void
    discardRequests()
    {
	adminImpl_.discardRequests();
    }
}
