// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package event;

import org.omg.CORBA.*;
import org.omg.CosTypedEventChannelAdmin.*;
import org.omg.CosEventChannelAdmin.*;
import java.io.*;
import java.util.*;

public class TSU
{
    public static void
    PrintStatusMsg(int current, String source, int level, String msg)
    {
        if(current >= level)
        {
	    System.err.println("[" + source + ": " + msg + "]");
        }
    }

    public static void
    PrintAny(Any any)
    {
	org.omg.CORBA.TypeCode type = any.type();

	if ((type.kind() == org.omg.CORBA.TCKind.tk_short) ||
	    (type.kind() == org.omg.CORBA.TCKind.tk_ushort))
	{
	    try
	    {
		short val = any.extract_short();
		System.out.println(val);
	    }
	    catch(org.omg.CORBA.BAD_OPERATION ex)
	    {
		ex.printStackTrace();
		System.exit(1);
	    }
	}
	else if ((type.kind() == org.omg.CORBA.TCKind.tk_long) ||
		 (type.kind() == org.omg.CORBA.TCKind.tk_ulong))
	{
	    try
	    {
		int val = any.extract_long();
		System.out.println(val);
	    }
	    catch(org.omg.CORBA.BAD_OPERATION ex)
	    {
		ex.printStackTrace();
		System.exit(1);
	    }
	}
	else if (type.kind() == org.omg.CORBA.TCKind.tk_double)
	{
	    try
	    {
		double val = any.extract_double();
		System.out.println(val);
	    }
	    catch(org.omg.CORBA.BAD_OPERATION ex)
	    {
		ex.printStackTrace();
		System.exit(1);
	    }
	}
	else if (type.kind() == org.omg.CORBA.TCKind.tk_float)
	{
	    try
	    {
		float val = any.extract_float();
		System.out.println(val);
	    }
	    catch(org.omg.CORBA.BAD_OPERATION ex)
	    {
		ex.printStackTrace();
		System.exit(1);
	    }
	}
	else if (type.kind() == org.omg.CORBA.TCKind.tk_boolean)
	{
	    try
	    {
		boolean val = any.extract_boolean();
		if(val)
		    System.out.println("true");
		else
		    System.out.println("false");
	    }
	    catch(org.omg.CORBA.BAD_OPERATION ex)
	    {
		ex.printStackTrace();
		System.exit(1);
	    }
	}
	else if (type.kind() == org.omg.CORBA.TCKind.tk_char)
	{
	    try
	    {
		char val = any.extract_char();
		System.out.println(val);
	    }
	    catch(org.omg.CORBA.BAD_OPERATION ex)
	    {
		ex.printStackTrace();
		System.exit(1);
	    }
	}
	else
	{	
	    System.out.println("undeceipherable type");
	}
    }
}
