// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.IMRConsole;

import java.util.*;

public class AppResources extends ListResourceBundle
{
    static final Object[][] contents_ =
    {
	// Menu items and accelerator characters
	{ "FileMenuKey",            "File" },
	{ "FileMenuMnemKey",        new Character('f') },
	{ "FileMenuAccelKey",       new Character((char)0) },
	{ "EditMenuKey",            "Edit" },
	{ "EditMenuMnemKey",        new Character('e') },
	{ "EditMenuAccelKey",       new Character((char)0) },
	{ "ViewMenuKey",            "View" },
	{ "ViewMenuMnemKey",        new Character('v') },
	{ "ViewMenuAccelKey",       new Character((char)0) },
	{ "HelpMenuKey",           "Help" },
	{ "HelpMenuMnemKey",       new Character('h') },
	{ "HelpMenuAccelKey",      new Character((char)0) },

	{ "ExitKey",                "Exit..." },
	{ "ExitMnemKey",            new Character('x') },
	{ "ExitAccelKey",           new Character('Q') },

	{ "CreateKey",              "Create..." },
	{ "CreateMnemKey",          new Character('c') },
	{ "CreateAccelKey",         new Character('N') },
	{ "ModifyKey",              "Modify..." },
	{ "ModifyMnemKey",          new Character('m') },
	{ "ModifyAccelKey",         new Character('M') },
        { "CutKey",                 "Cut" },
        { "CutMnemKey",             new Character('t') },
        { "CutAccelKey",            new Character('X') },
        { "PasteKey",               "Paste" },
        { "PasteMnemKey",           new Character('P') },
        { "PasteAccelKey",          new Character('V') },
	{ "DeleteKey",              "Delete..." },
        { "DeleteMnemKey",          new Character('d') },
        { "DeleteAccelKey",         new Character(
	    (char)java.awt.event.KeyEvent.VK_DELETE) },

  	{ "StartKey",               "Start..." },
  	{ "StartMnemKey",           new Character('s') },
  	{ "StartAccelKey",          new Character('S') },
  	{ "StopKey",                "Stop..." },
  	{ "StopMnemKey",            new Character('t') },
  	{ "StopAccelKey",           new Character('T') },
  	{ "ResetKey",               "Reset..." },
  	{ "ResetMnemKey",           new Character('r') },
  	{ "ResetAccelKey",          new Character('R') },

  	{ "RefreshKey",             "Refresh" },
  	{ "RefreshMnemKey",         new Character('r') },
  	{ "RefreshAccelKey",        new Character(
	    (char)java.awt.event.KeyEvent.VK_F5) },

  	{ "AboutKey",               "About..." },
  	{ "AboutMnemKey",           new Character('a') },
  	{ "AboutAccelKey",          new Character(
	    (char)java.awt.event.KeyEvent.VK_F1) },

        // Usage
	{ "UsageKey",
 
	  "Usage: java com.ooc.IMRConsole.Main [options]\n\n" +
	  "Options:\n" +
	  "--look CLASS      Specifies the Look & Feel CLASS.\n" +
	  "--windows         Shortcut for Windows Look & Feel " +
	  "(if available).\n" +
	  "--motif           Shortcut for Motif Look & Feel " +
	  "(if available).\n" +
	  "--mac             Shortcut for Macintosh Look & Feel " +
	  "(if available).\n" +
	  "-h, --help        Show this message.\n" +
	  "-v, --version     Show ORBacus IMR Console version."}
    };

    public Object[][]
    getContents()
    {
        return contents_;
    }
}
