// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.IMRConsole;

import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import com.ooc.IMR.*;

class OADDialog extends JDialog
{
    private static boolean new_;

    private static JTextField hostTxt_;
    private static JTextField upTxt_;
    
    private static OADDialog dialog_;
    private static OADInfo oadInfo_;
    private static OADInfo rtnOADInfo_;

    private static AbstractAction okAction_;
    private static AbstractAction cancelAction_;

    static OADInfo
    show(JFrame parent, String title, OADInfo oadInfo)
    {
	new_ = (oadInfo == null);
	if(new_)
	    oadInfo_ = new OADInfo("", false);
	else
	    oadInfo_ = oadInfo;
	    
        dialog_ = new OADDialog(parent, title);

	dialog_.setOADInfo();

        dialog_.setLocationRelativeTo(parent);
        dialog_.setVisible(true);

        return rtnOADInfo_;
    }

    private
    OADDialog(JFrame parent, String title)
    {
        super(parent, title, true);
        initializeActions();
	rtnOADInfo_ = null;
        setResizable(false);
        
	JPanel buttonPnl = initializeButtonPanel();
	JPanel setOADInfoPnl = initializeOADInfoPanel();
	
        JPanel mainPnl = new JPanel();
        mainPnl.setLayout(new BorderLayout());
        mainPnl.setBorder(BorderFactory.createEtchedBorder());
        mainPnl.add(setOADInfoPnl, BorderLayout.CENTER);

        JPanel holderPnl = new JPanel();
        holderPnl.setLayout(new BorderLayout());
        holderPnl.setBorder(BorderFactory.createEmptyBorder(5, 5, 5, 5));
        holderPnl.add(mainPnl, BorderLayout.CENTER);
        holderPnl.add(buttonPnl, BorderLayout.SOUTH);

        Container contentPane = getContentPane();
        contentPane.setLayout(new BorderLayout());
        contentPane.add(holderPnl, BorderLayout.SOUTH);

        pack();
    }

    private JPanel
    initializeButtonPanel()
    {
	JButton okBtn = new JButton("Ok");
        okBtn.addActionListener(okAction_);

        JButton cancelBtn = new JButton("Cancel");
        cancelBtn.addActionListener(cancelAction_);

	JPanel pnl = new JPanel();
        pnl.setLayout(new BoxLayout(pnl, BoxLayout.X_AXIS));
        pnl.setBorder(BorderFactory.createEmptyBorder(5, 0, 0, 0));
        pnl.add(Box.createHorizontalGlue());
        pnl.add(okBtn);
        pnl.add(Box.createRigidArea(new Dimension(5, 0)));
        pnl.add(cancelBtn);

	return pnl;
    }

    private JPanel
    initializeOADInfoPanel()
    {
	hostTxt_ = new JTextField(30);
	hostTxt_.setEnabled(new_);

	upTxt_ = new JTextField(30);
	upTxt_.setEnabled(false);

	JPanel pnl = new JPanel(new GridBagLayout());

	Util.addDialogHSpace(pnl);
	Util.addDialogParameterPair(pnl, "Host:", hostTxt_);
	Util.addDialogParameterPair(pnl, "Up:", upTxt_);

	Util.addDialogHSpace(pnl);

	return pnl;
    }

    private void
    initializeActions()
    {
        okAction_ = new OkAction();
        cancelAction_ = new CancelAction();
    }

    private void
    setOADInfo()
    {
	hostTxt_.setText(oadInfo_.host);
	upTxt_.setText(oadInfo_.up ? "Yes" : "No");
    }

    private void
    loadOADInfo()
    {
	rtnOADInfo_ = oadInfo_;
	rtnOADInfo_.host = hostTxt_.getText();
    }
    
    private class OkAction extends AbstractAction
    {
        public void
        actionPerformed(ActionEvent e)
        {
	    loadOADInfo();
	    dialog_.setVisible(false);
        }
    }

    private class CancelAction extends AbstractAction
    {
        public void
        actionPerformed(ActionEvent e)
        {
            dialog_.setVisible(false);
        }
    }  
}
