// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA  
//              
// All Rights Reserved   
//   
// **********************************************************************

package com.ooc.IMRConsole;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import com.ooc.IMR.*;

class ObjectTreeRenderer extends DefaultTreeCellRenderer
{
    private ImageIcon daIcon_;
    private ImageIcon oadIcon_;
    private ImageIcon serverIcon_;
    private ImageIcon poaIcon_;

    ObjectTreeRenderer()
    {
	daIcon_ = getImageResource("imr.gif");
	oadIcon_ = getImageResource("oad.gif");
	serverIcon_ = getImageResource("server.gif");
	poaIcon_ = getImageResource("poa.gif");
    }

    public Component
    getTreeCellRendererComponent(JTree tree,
				 Object value,
				 boolean sel,
				 boolean expanded,
				 boolean leaf,
				 int row,
				 boolean hasFocus) 
    {
	super.getTreeCellRendererComponent(
	    tree, value, sel, expanded, leaf, row, hasFocus);

	setEnabled(false);

	ServiceObject obj = (ServiceObject)value;
	setEnabled(obj.isValid());

	if(obj.isType(ServiceObject.DOMAIN))
	    setIcon(daIcon_);
	else if(obj.isType(ServiceObject.OAD))
	    setIcon(oadIcon_);
	else if(obj.isType(ServiceObject.SERVER))
	    setIcon(serverIcon_);
	else if(obj.isType(ServiceObject.POA))
	    setIcon(poaIcon_);
	    
	return this;
    }

    private ImageIcon
    getImageResource(String imageFile)
    {
	URL url = getClass().getResource("images/" + imageFile);
	if(url == null)
	    return null;

	return new ImageIcon(url);
    }
}
