// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.IMRConsole;

import java.lang.*;
import java.util.*;
import com.ooc.IMR.*;

final class ServerProps
{
    private String name_ = "";

    private ServerStatus status_ = ServerStatus.STOPPED;
    private boolean manual_ = false;
    private int updateTime_ = -1;
    private short timesForked_ = -1;

    private String host_ = "";
    private String exec_ = "";
    private String[] args_ = new String[0];
    private String directory_ = "";
    private ServerActivationMode mode_ = ServerActivationMode.SHARED;
    private boolean activatePOAs_ = true;

    private int updateTimeout_ = 1000;
    private int failureTimeout_ = 3;
    private short maxForks_ = 2;

    ServerProps()
    {
    }

    ServerProps(String name,
		ServerStatus status,
		boolean manual,
		int updateTime,
		short timesForked)
    {
	name_ = name;
	status_ = status;
	manual_ = manual;
	updateTime_ = updateTime;
	timesForked_ = timesForked;
    }

    public Object
    clone()
    {
	ServerProps sp =
	    new ServerProps(
		name_, status_, manual_, updateTime_, timesForked_);

	sp.setHost(host_);
	sp.setExec(exec_);

	String[] args = new String[args_.length];
	System.arraycopy(args_, 0, args, 0, args.length);
	sp.setArgs(args);

	sp.setDirectory(directory_);

	sp.setMode(mode_);
	sp.setActivatePOAs(activatePOAs_);
	sp.setUpdateTimeout(updateTimeout_);
	sp.setFailureTimeout(failureTimeout_);
	sp.setMaxForks(maxForks_);

	return sp;
    }
    
    void
    setName(String name)
    {
	name_ = name;
    }

    String
    getName()
    {
	return name_;
    }
    
    void
    setHost(String host)
    {
	host_ = host;
    }

    String
    getHost()
    {
	return host_;
    }

    void
    setExec(String exec)
    {
	exec_ = exec;
    }

    String
    getExec()
    {
	return exec_;
    }

    void
    setArgs(String[] args)
    {
	args_ = args;
    }

    String[]
    getArgs()
    {
	return args_;
    }

    void
    setDirectory(String directory)
    {
	directory_ = directory;
    }

    String
    getDirectory()
    {
	return directory_;
    }

    void
    setMode(ServerActivationMode mode)
    {
	mode_ = mode;
    }

    ServerActivationMode
    getMode()
    {
	return mode_;
    }

    void
    setActivatePOAs(boolean activatePOAs)
    {
	activatePOAs_ = activatePOAs;
    }

    boolean
    getActivatePOAs()
    {
	return activatePOAs_;
    }

    void
    setUpdateTimeout(int updateTimeout)
    {
	updateTimeout_ = updateTimeout;
    }

    int
    getUpdateTimeout()
    {
	return updateTimeout_;
    }

    void
    setFailureTimeout(int failureTimeout)
    {
	failureTimeout_ = failureTimeout;
    }

    int
    getFailureTimeout()
    {
	return failureTimeout_;
    }

    void
    setMaxForks(short maxForks)
    {
	maxForks_ = maxForks;
    }

    short
    getMaxForks()
    {
	return maxForks_;
    }

    ServerStatus
    getStatus()
    {
	return status_;
    }

    boolean
    getManual()
    {
	return manual_;
    }

    int
    getUpdateTime()
    {
	return updateTime_;
    }

    short
    getTimesForked()
    {
	return timesForked_;
    }
}
