// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA  
//                  
// All Rights Reserved   
//   
// **********************************************************************

package com.ooc.IMRConsole;

import java.net.*;
import java.lang.*;
import java.awt.*;
import javax.swing.*;

final class Util 
{
    static ImageIcon
    getImageResource(String imageFile, Object object)
    {
        URL url = object.getClass().getResource("images/" + imageFile);
        if(url == null)
	    return null;

	return new ImageIcon(url);
    }

    static void 
    addDialogHeader(Container container, String header) 
    {
        GridBagLayout gridbag = null;

        try 
	{
            gridbag = (GridBagLayout)(container.getLayout());
        } 
	catch(Exception e) 
	{
            return;
        }

	JLabel label = new JLabel(header);

        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.HORIZONTAL;
        c.insets = new Insets(0, 5, 0, 5);

        c.gridwidth = 2;
        c.weightx = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(label, c);
        container.add(label);
    }

    static void 
    addDialogInfo(Container container, String info) 
    {
        GridBagLayout gridbag = null;

        try 
	{
            gridbag = (GridBagLayout)(container.getLayout());
        } 
	catch(Exception e) 
	{
            return;
        }

	JTextArea textArea = new JTextArea(info);
	textArea.setColumns(20);
	textArea.setLineWrap(true);
	textArea.setWrapStyleWord(true);
	textArea.setEditable(false);
	textArea.setOpaque(false);

        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.BOTH;
        c.insets = new Insets(0, 5, 0, 5);

        c.gridwidth = 2;
        c.weighty = 1.0;
        c.weightx = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(textArea, c);
        container.add(textArea);
    }

    static void 
    addDialogParameter(Container container, Component component) 
    {
        GridBagLayout gridbag = null;

        try 
	{
            gridbag = (GridBagLayout)(container.getLayout());
        } 
	catch(Exception e) 
	{
            return;
        }

        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.HORIZONTAL;
        c.insets = new Insets(0, 5, 0, 5);

        c.gridwidth = 2;
        c.weightx = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(component, c);
        container.add(component);
    }

    static void 
    addDialogParameterPair(Container container, 
	                   String name, 
			   Component component) 
    {
        GridBagLayout gridbag = null;

        try 
	{
            gridbag = (GridBagLayout)(container.getLayout());
        } 
	catch(Exception e) 
	{
            return;
        }

	JLabel label = new JLabel(name);
	label.setEnabled(component.isEnabled());
	
        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.HORIZONTAL;
        c.insets = new Insets(0, 5, 0, 5);

        gridbag.setConstraints(label, c);
        container.add(label);
        c.gridwidth = GridBagConstraints.REMAINDER;
        c.weightx = 1.0;
        gridbag.setConstraints(component, c);
        container.add(component);
    }

    static void 
    addDialogHSpace(Container container) 
    {
        GridBagLayout gridbag = null;

        try 
	{
            gridbag = (GridBagLayout)(container.getLayout());
        } 
	catch(Exception e) 
	{
            return;
        }

	Component component = Box.createRigidArea(new Dimension(0, 15));

        GridBagConstraints c = new GridBagConstraints();
        c.fill = GridBagConstraints.HORIZONTAL;
        c.insets = new Insets(0, 5, 0, 5);

        c.gridwidth = 2;
        c.weightx = 1.0;
        c.gridwidth = GridBagConstraints.REMAINDER;
        gridbag.setConstraints(component, c);
        container.add(component);
    }

    static boolean
    isFloat(String str)
    {
	int decimalPos = str.indexOf(".");
	String start = "0"; 
	String end = "0";

	if(decimalPos < 0)
	    return false;
	else
	{
	    start = str.substring(0, decimalPos);
	    end = str.substring(decimalPos + 1, str.length());
	}

        try
        {
	    Integer.parseInt(start);
	    Integer.parseInt(end);
        }
        catch(NumberFormatException ex)
        {
            return false;
        }

	return true;
    }
}
