// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosNaming;

//
// This class is used to update the database journal on a regular
// basis.
//
final class Compactor extends Thread
{
    private org.omg.CORBA.ORB orb_;

    private NamingDatabase store_;

    private int interval_; // Timeout interval

    private boolean stop_;

    private com.ooc.OB.Logger logger_;
    private int traceLevel_;

    Compactor(org.omg.CORBA.ORB orb, NamingDatabase store, int logSeconds,
	      int traceLevel)
    {
	orb_ = orb;
	store_ = store;
	interval_ = logSeconds;
	traceLevel_ = traceLevel;

	com.ooc.OBCORBA.ORB_impl oborb = (com.ooc.OBCORBA.ORB_impl)orb;
	logger_ = oborb.logger();
    }

    synchronized void
    halt()
    {
	stop_ = true;
	notify();
    }

    synchronized public void
    run()
    {
	while(!stop_)
	{
	    try
	    {
		wait(interval_ * 1000);
	    }
	    catch(InterruptedException ex)
	    {
	    }
	    if(stop_)
		continue;
	    if(traceLevel_ >= 2)
		logger_.trace("naming", "compacting database");
	    store_.updateJournal();
	}
    }
}
