// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package account;

public class Example_impl extends ExamplePOA
{
    public void
    display(Describable d)
    {
        //
        // Obtain a description of the Describable object. If the object
        // is an object reference, then this will be a remote invocation.
        // Otherwise, if the object is a valuetype, this will be a
        // local operation.
        //
        String desc = d.get_description();

        //
        // For illustrative purposes, we discover whether the given
        // Describable object is an Account or a Currency
        //
        Account account = null;
        Currency currency = null;
        try
        {
            account = AccountHelper.narrow(d);
        }
        catch(org.omg.CORBA.BAD_PARAM ex)
        {
            // AccountHelper.narrow() failed
        }
        try
        {
            currency = (Currency)d;
        }
        catch(ClassCastException ex)
        {
            // Cast to Currency failed
        }

        if(account != null)
            System.out.println("Received an Account object: " + desc);
        else if(currency != null)
            System.out.println("Received a Currency object: " + desc);
    }
}
