// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package benchmark;

import benchmark.*;
import benchmark.Benchmark.*;

public class CallUserTypeTester
{
    private org.omg.CORBA.ORB orb_;

    public
    CallUserTypeTester(org.omg.CORBA.ORB orb)
    {
        orb_ = orb;
    }

    public void
    u1_in_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u1 u = new benchmark.UserTypes.u1();
	u.s((short) 7);

	System.out.print(iterations + " Union small in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.u1_in_t(u);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u1_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    u1_out_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u1Holder u = new benchmark.UserTypes.u1Holder();

	System.out.print(iterations + " Union small out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.u1_out_t(u);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u1_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    u1_inout_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u1Holder u = new benchmark.UserTypes.u1Holder();
	u.value = new benchmark.UserTypes.u1();
	u.value.c('g');

	System.out.print(iterations + " Union small in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.u1_inout_t(u);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u1_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    u1_ret_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u1 u;

	System.out.print(iterations + " Union small in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        u = obj.u1_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u1_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    u2_in_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u2 u = new benchmark.UserTypes.u2();
	u.ll((long) 443L);

	System.out.print(iterations + " Union large in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.u2_in_t(u);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u2_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    u2_out_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u2Holder u = new benchmark.UserTypes.u2Holder();

	System.out.print(iterations + " Union large out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.u2_out_t(u);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u2_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    u2_inout_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u2Holder u = new benchmark.UserTypes.u2Holder();
	u.value = new benchmark.UserTypes.u2();
	u.value.d(234343.772);

	System.out.print(iterations + " Union large in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.u2_inout_t(u);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u2_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    u2_ret_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.u2 u;

	System.out.print(iterations + " Union large in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        u = obj.u2_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("u2_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s1_in_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s1 s = new benchmark.UserTypes.s1();
	s.s = 44;

	System.out.print(iterations + " Struct small in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.s1_in_t(s);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s1_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s1_out_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s1Holder s = new benchmark.UserTypes.s1Holder();

	System.out.print(iterations + " Struct small out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.s1_out_t(s);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s1_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s1_inout_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s1Holder s = new benchmark.UserTypes.s1Holder();
	s.value = new benchmark.UserTypes.s1();
	s.value.s = 34;

	System.out.print(iterations + " Struct small in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.s1_inout_t(s);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s1_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s1_ret_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s1 s;

	System.out.print(iterations + " Struct small in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        s = obj.s1_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s1_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s2_in_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s2 s = new benchmark.UserTypes.s2();
	s.s = 4;
	s.l = 234235;
	s.ll = 2304020023040L;
	s.us = 443;
	s.ul = 8;
	s.f = 4434.87F;
	s.d = 187.7;
	s.c = 'h';
	s.wc = '(';
	s.st = "Hi, Mom!";
	s.ws = "Hi, Dad!";
	s.b = false;
	s.o = 7;
	s.a = orb_.create_any();
	s.a.insert_string("I'm going in an any...");

	System.out.print(iterations + " Struct large in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.s2_in_t(s);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s2_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s2_out_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s2Holder s = new benchmark.UserTypes.s2Holder();

	System.out.print(iterations + " Struct large out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.s2_out_t(s);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s2_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s2_inout_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s2Holder s = new benchmark.UserTypes.s2Holder();
	s.value = new benchmark.UserTypes.s2();
	s.value.s = 234;
	s.value.l = 723456235;
	s.value.ll = 2303454020023040L;
	s.value.us = (short) 43343;
	s.value.ul = 338;
	s.value.f = 45434.857F;
	s.value.d = 1857.37;
	s.value.c = 'q';
	s.value.wc = 'b';
	s.value.st = "Lemond";
	s.value.ws = "Howdy";
	s.value.b = false;
	s.value.o = 7;
	s.value.a = orb_.create_any();
	s.value.a.insert_string("Erin go bragh!");

	System.out.print(iterations + " Struct large in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.s2_inout_t(s);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s2_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    s2_ret_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.s2 s;

	System.out.print(iterations + " Struct large in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        s = obj.s2_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("s2_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }
    
    public void
    interface_in_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.I interf = null;

	System.out.print(iterations + " Interfaces in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.interface_in_t(interf);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("interface_in_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    interface_out_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.IHolder interf = new benchmark.UserTypes.IHolder();

	System.out.print(iterations + " Interfaces out: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.interface_out_t(interf);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("interface_out_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    interface_inout_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.IHolder interf = new benchmark.UserTypes.IHolder();
	interf.value = null;

	System.out.print(iterations + " Interfaces in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        obj.interface_inout_t(interf);

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("interface_inout_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }

    public void
    interface_ret_t(UserTypeTester obj, long iterations)
    {
        benchmark.UserTypes.I interf;

	System.out.print(iterations + " Interfaces in: \t");
	Timer t = new Timer();

	try
	{
	    t.start();

	    for(long i = 0; i < iterations; i++)
	        interf = obj.interface_ret_t();

	    t.stop();
	}
	catch(org.omg.CORBA.SystemException ex)
	{
	    System.err.println("interface_ret_t(): call failed\n" + ex);
	    return;
	}

	System.out.println("\t" + t.timeElapsed() + " seconds (" +
			   (iterations / t.timeElapsed()) + "/sec)");
    }
}
