// ********************************************************************* 
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
// 
// All Rights Reserved
//
// **********************************************************************

import java.math.*;
import types.*;
import org.omg.CORBA.*;

public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
    {    
	Any any = orb.create_any();
	TypeCode tc = null;

        int i;

	{
	    // interface

	    util.show_TC(hello.HelloHelper.type());
	}

        {
	    // short

            short v = -32768;

            any.insert_short(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // unsigned short

            short v = (short)65535;

            any.insert_ushort(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // long

            int v = -2147483647 - 1;

            any.insert_long(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // unsigned long

            int v = 2147483647;

            any.insert_ulong(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // long long

            long v = -9223372036854775807L - 1;

            any.insert_longlong(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // unsigned long long

            long v = 9223372036854775807L;

            any.insert_ulonglong(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // float

            float v = (float)1.23456789;

            any.insert_float(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // double

            double v = 1E200;

            any.insert_double(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // octet

            byte v = (byte)0xff;

            any.insert_octet(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // character

            char v = 'x';

            any.insert_char(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // wide character

            char v = 'x';

            any.insert_wchar(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // boolean 

            boolean v = true;

            any.insert_boolean(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // string

            String v = "Hello";

            any.insert_string(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // wide string

            String v = "Hello";

            any.insert_wstring(v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // fixed

            BigDecimal v1 = new BigDecimal("-123456789");

            any.insert_fixed(v1, orb.create_fixed_tc((short)24, (short)0));
	    tc = any.type();
	    util.show_TC(tc);

        }

        {
	    // structure

            TestStruct1 v = new TestStruct1();
            v.s = -32768;
            v.l = -2147483647 - 1;
            v.d = 1E200;
            v.b = true;
            v.c = 'x';
            v.o = (byte)0xff;
            v.str = "abc";

            TestStruct1Helper.insert(any, v);
	    tc = any.type();
	    util.show_TC(tc);

	    // nested structure

            TestStruct2 v2 = new TestStruct2();
            v2.da = new double[10][20][30];
            v2.sa = new String[100];
            for(i = 0 ; i < 100 ; i++)
                v2.sa[i] = "";
            v2.s = v;
            v2.a = any;
            v2.da[0][0][0] = 1.23;
            v2.da[2][3][4] = -1.11;
            v2.sa[50] = "Hi!";

            Any any2 = orb.create_any();
            TestStruct2Helper.insert(any2, v2);
	    tc = any2.type();
	    util.show_TC(tc);
        }

        {
	    // enum

            TestEnum v = TestEnum.B;
            TestEnumHelper.insert(any, v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // typedef

            String[] v = new String[40];

            for(i = 0 ; i < 40 ; i++)
                v[i] = "abc";

            String40SeqHelper.insert(any, v);
	    tc = any.type();
	    util.show_TC(tc);
        }

        {
	    // typecode

            any.insert_TypeCode(TestStruct1Helper.type());
	    tc = any.extract_TypeCode();
	    util.show_TC(tc);
        }

	{
	    // union

	    TestUnion1 u = new TestUnion1();
	    u.l(123);

	    u.tc(-6, TestUnion1Helper.type());
	    tc = u.tc();
	    util.show_TC(tc);
	}

        return 0;
    }

    public static void
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

	int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
        }
        catch(RuntimeException ex)
        {
            ex.printStackTrace();
            status = 1;
        }

	if(orb != null)
        {
	    try
            {
		orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

	System.exit(status);
    }
}
