// ********************************************************************* 
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
// 
// All Rights Reserved
//
// **********************************************************************

package time;

public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
	// Check arguments
	if(args.length != 1)
        {
	    System.err.println("Usage: java Client IOR_string");
	    return 1;
	}

	// Destringify argv[0]
	org.omg.CORBA.Object obj = orb.string_to_object(args[0]);
	if(obj == null)
        {
	    System.err.println("Nil Time reference");
	    return 1;
	}

	// Narrow
	Time tm = null;
	try
        {
	    tm = TimeHelper.narrow(obj);
	}
	catch(org.omg.CORBA.BAD_PARAM ex)
        {
	    System.err.println("Argument is not a Time reference");
	    return 1;
	}

	// Get time
	TimeOfDay tod = tm.get_gmt();
	System.err.println("Time in Greenwich is "
			   + tod.hour + ":" 
			   + tod.minute + ":" 
			   + tod.second);
        return 0;
    }

    public static void 
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

	int status = 0;
        org.omg.CORBA.ORB orb = null;

	try
        {
            org.omg.CORBA.StringSeqHolder argsH =
                new org.omg.CORBA.StringSeqHolder(args);
            orb = com.ooc.CORBA.ORB.init(argsH, props, null);
            status = run(orb, argsH.value);
	} 
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

	if(orb != null)
        {
	    try
            {
		orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
