// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package chat;

import chat.BroadcasterAdminPackage.*;

final public class Broadcaster_impl extends BroadcasterPOA
{
    private BroadcasterAdmin_impl admin_;
    private int id_;
    private org.omg.PortableServer.POA poa_;

    Broadcaster_impl(
	BroadcasterAdmin_impl admin, 
	int id,
	org.omg.PortableServer.POA poa
    )
    {
	admin_ = admin;
	id_    = id;
	poa_   = poa;
    }

    public org.omg.PortableServer.POA
    _default_POA()
    {
	return poa_;
    }

    //        
    // Unsubscribe receiver
    //
    public void 
    unsubscribe()
    {
	admin_.unregister(id_);
    }


    //        
    // Set the nick name
    //
    public void
    setNickName(String nick)
        throws NickExists
    {
        admin_.setNickName(id_, nick);
    }


    //
    // Say something
    //
    public void
    say(String message)
    {
	admin_.say(message);
    }

} 
