// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

import java.awt.*;
import java.awt.event.*;

final class AwtEchoClient extends Frame implements ActionListener
{
    private static echo.Echo echo_;
    private TextField message_;
    private final int msgCols_ = 20;
    private static org.omg.CORBA.ORB orb_;
    private static int status_ = 0;

    AwtEchoClient()
    {
	super();
	setLayout(new BorderLayout());
	Panel p;
	Button b;
	add("North", new Label("Echo Client"));
	p = new Panel();
	add("Center", message_ = new TextField(msgCols_));
	Panel p2 = new Panel();
	p2.setLayout(new GridLayout(2, 1));
	p = new Panel();
	b = new Button("Message");
	b.setActionCommand(b.getLabel());
	b.addActionListener((ActionListener) this);
	p.add(b);

	b = new Button("Clear");
	b.setActionCommand(b.getLabel());
	b.addActionListener((ActionListener) this);
	p.add(b);
	p2.add(p);

	p = new Panel();
	b = new Button("Exit");
	b.setActionCommand(b.getLabel());
	b.addActionListener((ActionListener) this);
	p.add(b);
	p2.add(p);
	add("South", p2);

	pack();
    }

    public synchronized void
    actionPerformed(ActionEvent e)
    {
	if(e.getActionCommand().equals("Message"))
	{
	    // Send Message
	    String msg = message_.getText();
	    message_.setText(echo_.echo_message(msg));
	}
	if(e.getActionCommand().equals("Clear"))
	{
	    message_.setText("");
	}
	if(e.getActionCommand().equals("Exit"))
	{
	    if(orb_ != null)
	    {
		try
		{
		    orb_.destroy();
		}
		catch(Exception ex)
		{
		    ex.printStackTrace();
		    status_ = 1;
		}
	    }
	    System.exit(status_);
	}
	notifyAll();
    }

    public void windowClosing(WindowEvent e) 
    {
	System.exit(0);
    }
    public static void
    main(String[] args)
    {
	try
	{
	    java.util.Properties props = System.getProperties();
	    props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	    props.put("org.omg.CORBA.ORBSingletonClass",
		      "com.ooc.CORBA.ORBSingleton");

            orb_ = org.omg.CORBA.ORB.init(args, null);

	    //
	    // Get "Echo" object
	    //
	    org.omg.CORBA.Object obj = 
		orb_.string_to_object("relfile:/Echo.ref");
	    if(obj == null)
	    {
		System.err.println(
		    "EchoAwtClient: cannot read IOR from Echo.ref");
		System.exit(1);
	    }
	    
	    echo_ = echo.EchoHelper.narrow(obj);
	    if(echo_ == null)
	    {
		System.err.println("Not an Echo reference!");
		System.exit(1);
	    }
	    
	    AwtEchoClient ac = new AwtEchoClient();
	    ac.addWindowListener(new WindowAdapter() 
		{
		    public void windowClosing(WindowEvent e) 
		    {
			if(orb_ != null)
			{
			    try
			    {
				orb_.destroy();
			    }
			    catch(Exception ex)
			    {
				ex.printStackTrace();
				status_ = 1;
			    }
			}
			System.exit(status_);
		    }
		});

	    ac.show();	
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status_ = 1;
	}
    }
}
