// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************


final public class EchoClient
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
	throws org.omg.CORBA.UserException
    {
	//
	// Get "echo" object
	//
        org.omg.CORBA.Object obj = orb.string_to_object("relfile:/Echo.ref");
	if(obj == null)
	{
	    System.err.println("EchoClient: cannot read IOR from Echo.ref");
	    return 1;
	}

	echo.Echo ec = echo.EchoHelper.narrow(obj);

	//
	// Main loop
	//
	System.out.println("Enter 'h' for 'Hello!', 'm' for message or 'x' for exit:");
	try
	{
	    String input;
	    do
	    {
		System.out.print("> ");
                java.io.BufferedReader in = new java.io.BufferedReader(
                    new java.io.InputStreamReader(System.in));
		input = in.readLine();
                if(input == null)
                    break;

		if(input.equals("h"))
		{
		    System.out.println(ec.echo_message("Hello!"));
		}
		if(input.equals("m"))
		{
		    System.out.println("Type Message string and RETURN.");
		    input = in.readLine();
		    System.out.println(ec.echo_message(input));
		}
	    }
	    while(!input.equals("x"));
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("Can't read from `" + ex.getMessage() + "'");
	    return 1;
	}

	return 0;
    }

    public static void
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

	System.out.println("-- Echo-Client--");
	int status = 0;
	org.omg.CORBA.ORB orb = null;

	try
	{
            orb = org.omg.CORBA.ORB.init(args, null);
	    status = run(orb, args);
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}
