// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

final public class EchoServer
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
	throws org.omg.CORBA.UserException
    {
	//
	// Resolve Root POA
	//
	org.omg.PortableServer.POA rootPOA =
	    org.omg.PortableServer.POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));

	//
	// Get a reference to the POA manager
	//
	org.omg.PortableServer.POAManager manager = rootPOA.the_POAManager();

	//
	// Create implementation object
	//
	Echo_impl echoImpl = new Echo_impl(rootPOA);
	echo.Echo ec = echoImpl._this(orb);

	//
	// Add reference to boot manager
	//
	try
	{
	    byte[] oid = ("Echo").getBytes();
	    com.ooc.OB.BootManager bootManager = 
		com.ooc.OB.BootManagerHelper.narrow(
		    orb.resolve_initial_references("BootManager"));
	    bootManager.add_binding(oid, ec);
	}
	catch(org.omg.CORBA.ORBPackage.InvalidName ex)
	{
	    throw new RuntimeException();
	}
	catch(com.ooc.OB.BootManagerPackage.AlreadyExists ex)
	{
	    throw new RuntimeException();
	}

	//
	// Save reference
	//
	try
	{
	    String ref = orb.object_to_string(ec);
	    String refFile = "Echo.ref";
            java.io.FileOutputStream file =
                new java.io.FileOutputStream(refFile);
            java.io.PrintWriter out = new java.io.PrintWriter(file);
	    out.println(ref);
	    out.flush();
	    file.close();
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("EchoServer: can't write to `" +
                               ex.getMessage() + "'");
	    return 1;
	}

	//
	// Run implementation
	//
	manager.activate();
	orb.run();

	return 0;
    }

    public static void
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

	System.out.println("-- Echo-Server --");
	int status = 0;
	org.omg.CORBA.ORB orb = null;

	try
	{
	    orb = org.omg.CORBA.ORB.init(args, null);
	    status = run(orb, args);
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}
