// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package factory;

public class LocRecord_impl extends factory.DBRecordPOA
{
    private Database.DBRecordData data_;
    private boolean debug_;

    public
    LocRecord_impl(Database.DBRecordData data, boolean debug)
    {
        data_ = data;
	debug_ = debug;

	if(debug_)
        {
            String msg = "LocRecord_impl (";
            msg += data_.key;
            msg += ", `";
            msg += data_.data;
            msg += "') instantiated.";
	    System.out.println(msg);
        }
    }

    protected void
    finalize()
        throws Throwable
    {
	if(debug_)
        {
            String msg = "LocRecord_impl (";
            msg += data_.key;
            msg += ", `";
            msg += data_.data;
            msg += "') deleted.";
	    System.out.println(msg);
        }
    }

    public int
    key()
    {
        return data_.key;
    }

    public String
    data()
    {
        return data_.data;
    }

    public void
    data(String str)
    {
        data_.data = str;
    }
}
