// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package factory;

//
// A ReapTimer invokes reap() on a reaper at a given interval
//
public class ReapTimer extends Thread
{
    Reaper reaper_;
    int interval_;

    public
    ReapTimer(Reaper reaper, int interval)
    {
        reaper_ = reaper;
        interval_ = interval;

        new Thread(this).start();
    }

    public void
    run()
    {
        while(true)
        {
            try
            {
                sleep(interval_ * 1000);

                //
                // Invoke the reaper
                //
                reaper_.reap();
            }
            catch(InterruptedException ex)
            {
            }
        }
    }
}
