// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package hello;

public class Collocated
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
	throws org.omg.CORBA.UserException
    {
	//
	// Resolve Root POA
	//
	org.omg.PortableServer.POA rootPOA =
	    org.omg.PortableServer.POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));

	//
	// Get a reference to the POA manager
	//
	org.omg.PortableServer.POAManager manager = rootPOA.the_POAManager();

	//
	// Create implementation object
	//
	Hello_impl helloImpl = new Hello_impl(rootPOA);
	Hello hello = helloImpl._this(orb);

	//
	// Run implementation
	//
	manager.activate();

        //
	// Main loop
	//
	System.out.println("Enter 'h' for hello or 'x' for exit:");
	try
	{
	    String input;
	    do
	    {
		System.out.print("> ");
		java.io.BufferedReader in = new java.io.BufferedReader(
		    new java.io.InputStreamReader(System.in));
		input = in.readLine();

		if(input.equals("h"))
		    hello.say_hello();
                else if(input.equals("s"))
		    hello.shutdown();
	    }
	    while(!input.equals("x"));
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("Can't read from `" + ex.getMessage() + "'");
	    return 1;
	}

	orb.shutdown(true);

	return 0;
    }

    public static void
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");
	props.put("ooc.orb.id", "Hello-Collocated");

	int status = 0;
	org.omg.CORBA.ORB orb = null;

	try
	{
	    orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}
