// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package pi;

//
// Servant implementing PIDemo using static skeletons
//
final class PIDemo_impl
    extends PIDemoPOA
{
    //
    // My ORB
    //
    private org.omg.CORBA.ORB orb_;

    //
    // My POA
    //
    private org.omg.PortableServer.POA poa_;

    //
    // A reference to the object corresponding to the static
    // implementation (used by call_other_impl())
    //
    private PIDemo otherObj_;

    // -----------------------------------------------------------------
    // PIDemo_impl constructor
    // -----------------------------------------------------------------

    public PIDemo_impl(org.omg.CORBA.ORB orb,
    		       org.omg.PortableServer.POA poa)
    {
	orb_ = orb;
	poa_ = poa;
    }

    // -----------------------------------------------------------------
    // PIDemo_impl public member implementation
    // -----------------------------------------------------------------

    //
    // Set the reference to the object corresponding to the
    // dynamic implementation
    //
    public void
    setOtherObj(PIDemo obj)
    {
	otherObj_ = obj;
    }

    // -----------------------------------------------------------------
    // Standard IDL to Java mapping
    // -----------------------------------------------------------------

    //
    // IDL:PIDemo/noargs:1.0
    //
    public void noargs()
    {
    }

    //
    // IDL:PIDemo/noargs_oneway:1.0
    //
    public void noargs_oneway()
    {
    }

    //
    // IDL:PIDemo/noargs_return:1.0
    //
    public String noargs_return()
    {
	return "PIDemo";
    }

    //
    // IDL:PIDemo/withargs:1.0
    //
    public void withargs(String str1, org.omg.CORBA.StringHolder str2,
    			 org.omg.CORBA.StringHolder str3)
    {
	str2.value = "PIDemo";
	str3.value = "PIDemo";
    }

    //
    // IDL:PIDemo/systemexception:1.0
    //
    public void systemexception()
    {
	throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    //
    // IDL:PIDemo/userexception:1.0
    //
    public void userexception()
        throws pi.PIDemoPackage.User
    {
	throw new pi.PIDemoPackage.User();
    }

    //
    // IDL:PIDemo/switch_to_static_impl:1.0
    //
    public void switch_to_static_impl()
    {
    }

    //
    // IDL:PIDemo/switch_to_dynamic_impl:1.0
    //
    public void switch_to_dynamic_impl()
    {
    }

    //
    // IDL:PIDemo/call_other_impl:1.0
    //
    public void call_other_impl(short level)
    {
	if(otherObj_ != null && level > 0)
	    otherObj_.call_other_impl(--level);
    }

    //
    // IDL:PIDemo/deactivate:1.0
    //
    public void deactivate()
    {
	orb_.shutdown(false);
    }

    public org.omg.PortableServer.POA
    _default_POA()
    {
        return poa_;
    }
}
