// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package random;

final public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
	// We are connecting to an Orbix server. Note that we can
	// either use the generated IOR, or the corbaloc form. The
	// object key for corbaloc was extracted using iordump.
	//
	String randomIOR = "IOR:000000000000000f49444c3a52616e646f6d3a312e3000000000000100000000000000500001000000000016706c616e7874792e6473672e63732e7463642e69650006220000002c3a5c706c616e7874792e6473672e63732e7463642e69653a52616e646f6d3a303a3a49523a52616e646f6d00";

	//
	// Note that this doesn't work since this type of IOR doesn't
	// have a RepositoryID. This means that ORBacus calls _is_a on
	// the call to _narrow below -- but unfortunately ORBIX has
	// some bugs related to _is_a which causes the _narrow to
	// fail.
	//
	// String randomIOR = "corbaloc::planxty.dsg.cs.tcd.ie:1570/"
	// ":\\planxty.dsg.cs.tcd.ie:Random:0::IR:Random";
	//
	org.omg.CORBA.Object obj = orb.string_to_object(randomIOR);
	if(obj == null)
	    throw new RuntimeException();

	Random random = RandomHelper.narrow(obj);

	//
	// Main loop
	//
	System.out.println("Enter 'r' for a random number, or 'x' for exit:");

	int c;

	try
	{
	    String input;
	    do
	    {
		System.out.print("> ");
		java.io.BufferedReader in = new java.io.BufferedReader(
		    new java.io.InputStreamReader(System.in));
		input = in.readLine();

		if(input.equals("r"))
		{
		    int l = random.lrand48();
		    System.out.println(l);
		}
            }
	    while(!input.equals("x"));
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("random.Client: can't read from `" +
                               ex.getMessage() + "'");
	    return 1;
	}

	return 0;
    }

    public static void
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

	int status = 0;
	org.omg.CORBA.ORB orb = null;

	try
	{
	    orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
	    status = 1;
        }

  	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
                ex.printStackTrace();
                status = 1;
	    }
	}

        System.exit(status);
    }
}
