// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package Simple;

import java.awt.*;
import java.awt.event.*;

final public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
	throws org.omg.CORBA.UserException
    {
	//
	// Get "simple" objects
	//
	org.omg.CORBA.Object obj1 =
	    orb.string_to_object("relfile:/simple1.ior");
	if(obj1 == null)
	{
	    System.err.println(
		"Simple.Client: cannot read IOR from simple1.ior");
	    return 1;
	}

	org.omg.CORBA.Object obj2 =
	    orb.string_to_object("relfile:/simple2.ior");
	if(obj2 == null)
	{
	    System.err.println(
		"Simple.Client: cannot read IOR from simple2.ior");
	    return 1;
	}

	SimpleObject simple1 = SimpleObjectHelper.narrow(obj1);

	SimpleObject simple2 = SimpleObjectHelper.narrow(obj2);

	//
	// Call implementations
	//
	simple1.call_me();
	simple2.call_me();

	return 0;
    }

    //
    // Standalone program initialization
    //
    public static void
    main(String args[])
    {
	int status = 0;
	org.omg.CORBA.ORB orb = null;

	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");
	props.put("ooc.orb.id", "Simple-Client");

	try
	{
            orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
	}
	catch(Exception ex)
	{
	    ex.printStackTrace();
	    status = 1;
	}

	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
		ex.printStackTrace();
		status = 1;
	    }
	}

	System.exit(status);
    }
}
