// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package value;

public class Client
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Instantiate value factory
        //
        // NOTE: There's no need to register this factory with the ORB
        //       unless we will be receiving a Employee value.
        //
        EmployeeFactory_impl factory = new EmployeeFactory_impl();

        //
        // Obtain the server's object reference from a file
        //
        org.omg.CORBA.Object obj =
            orb.string_to_object("relfile:/Payroll.ref");
        if(obj == null)
        {      
            System.err.println("value.Client: " +
                               "cannot read IOR from Payroll.ref");
            return 1;
        }

        Payroll payroll = PayrollHelper.narrow(obj);

        //
        // Test with null value
        //
        payroll.pay_employee(null);

        //
        // Test with real value
        //
        value.Employee emp1 = factory.create(1000.0f);
        emp1.emp_id = 999;
        emp1.name = "John Smith";
        emp1.addr = new value.EmployeePackage.Address();
        emp1.addr.street = "1234 Maiden Lane";
        emp1.addr.city = "Somewhere";
        emp1.addr.state = "CA";
        emp1.addr.zip = "95000";
        emp1.ssn = "123-45-6789";
        System.out.println("Paying " + emp1.name);
        payroll.pay_employee(emp1);

        return 0;
    }

    public static void
    main(String[] args)
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            orb = org.omg.CORBA.ORB.init(args, props);
            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
