// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OB;

final class CodeConverterNone extends CodeConverterBase
{
    // ------------------------------------------------------------------
    // Constructor
    // ------------------------------------------------------------------

    CodeConverterNone(CodeSetInfo fromSet, CodeSetInfo toSet)
    {
        super(fromSet, toSet);
    }

    // ------------------------------------------------------------------
    // Public member implementations
    // ------------------------------------------------------------------

    public boolean
    conversionRequired()
    {
	return true;
    }

    public char
    read_wchar(com.ooc.CORBA.InputStream in, int len)
    {
        throw new org.omg.CORBA.BAD_PARAM(
            MinorCodes.describeBadParam(MinorCodes.MinorNoWcharCodeSet),
            MinorCodes.MinorNoWcharCodeSet,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public void
    write_wchar(com.ooc.CORBA.OutputStream out, char v)
    {
        throw new org.omg.CORBA.INV_OBJREF(
            MinorCodes.describeInvObjref(MinorCodes.MinorWcharCodeSetRequired),
            MinorCodes.MinorWcharCodeSetRequired,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public int
    count_wchar(byte value)
    {
        throw new org.omg.CORBA.BAD_PARAM(
            MinorCodes.describeBadParam(MinorCodes.MinorNoWcharCodeSet),
            MinorCodes.MinorNoWcharCodeSet,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public int
    count_wchar(char v)
    {
        throw new org.omg.CORBA.INV_OBJREF(
            MinorCodes.describeInvObjref(MinorCodes.MinorWcharCodeSetRequired),
            MinorCodes.MinorWcharCodeSetRequired,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }

    public char
    convert(char v)
    {
        throw new org.omg.CORBA.INV_OBJREF(
            MinorCodes.describeInvObjref(MinorCodes.MinorWcharCodeSetRequired),
            MinorCodes.MinorWcharCodeSetRequired,
            org.omg.CORBA.CompletionStatus.COMPLETED_NO);
    }
}
