// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OB;

final class CodeConverterTo extends CodeConverterBase
{
    //
    // Unicode character mapping table
    //
    private CharMapInfo toMap_;

    // ------------------------------------------------------------------
    // Constructor
    // ------------------------------------------------------------------

    CodeConverterTo(CodeSetInfo fromSet, CodeSetInfo toSet, CharMapInfo toMap)
    {
        super(fromSet, toSet);

	toMap_ = toMap;
    }

    // ------------------------------------------------------------------
    // Public member implementations
    // ------------------------------------------------------------------

    public boolean
    conversionRequired()
    {
	return true;
    }

    public char
    convert(char v)
    {
	for(int i = 0 ; i <= toMap_.upper_bound ; i++)
	{
	    if(toMap_.map_values[i] == v)
		return (char)i;
	}

        return v;
    }
}
