// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OB;

final class FixedWidth2Reader implements CodeSetReader
{
    public char
    read_char(com.ooc.CORBA.InputStream in)
        throws org.omg.CORBA.DATA_CONVERSION
    {
	//
	// Note: byte must be masked with 0xff to correct negative values
	//
	return (char)(in.buf_.data_[in.buf_.pos_++] & 0xff);
    }

    public char
    read_wchar(com.ooc.CORBA.InputStream in, int len)
        throws org.omg.CORBA.DATA_CONVERSION
    {
	if(len == 2)
	{
	    return (char)((in.buf_.data_[in.buf_.pos_++] << 8) |
			  (in.buf_.data_[in.buf_.pos_++] & 0xff));
	}
	else
	    throw new org.omg.CORBA.DATA_CONVERSION();
    }

    public int
    count_wchar(byte value)
    {
	return 2;
    }
}
