// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OB;

public class RecursiveMutex
{
    private Thread owner_;
    private boolean locked_;
    private int count_;

    public
    RecursiveMutex()
    {
        owner_ = null;
        locked_ = false;
        count_ = 0;
    }

    public synchronized void
    lock()
    {
        if(locked_ && Thread.currentThread() == owner_)
        {
            count_++;
            return;
        }

        while(locked_)
        {
            try
            {
                wait();
            }
            catch(InterruptedException ex)
            {
            }
        }

        //
        // Assert: owner_ == null, count_ = 0
        //
        locked_ = true;
        owner_ = Thread.currentThread();
        count_ = 1;
    }

    public synchronized void
    unlock()
    {
        // Assert: owner_ == Thread.currentThread, count_ > 0, locked = true
        count_--;
        if(count_ <= 0)
        {
            locked_ = false;
            owner_ = null;
            notifyAll();
        }
    }
}
