// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OB;

abstract public class Server
{
    //
    // The concurrency model for this Server
    //
    final public static int Blocking = 0;
    final public static int Threaded = 2;
    protected int concModel_ = Blocking;

    // ----------------------------------------------------------------------
    // Server package member implementations
    // ----------------------------------------------------------------------

    Server(int concModel)
    {
	concModel_ = concModel;
    }

    //
    // Destroy the server
    //
    abstract void
    destroy();

    //
    // Hold any new requests that arrive for the Server
    //
    abstract void
    hold();

    //
    // Dispatch any requests that arrive for the Server
    //
    abstract void
    activate();
}
