// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OBPortableServer;

class ServantLocationStrategyFactory
{
    static public ServantLocationStrategy
    createServantLocationStrategy(
	com.ooc.OBPortableServer.POAPolicies policies,
	com.ooc.OB.ORBInstance orbInstance)
    {
	if(policies.requestProcessingPolicy() ==
	   org.omg.PortableServer.RequestProcessingPolicyValue.
	   USE_ACTIVE_OBJECT_MAP_ONLY)
	    return new ActiveObjectOnlyStrategy(policies, orbInstance);
	
	ServantLocatorStrategy servantLocator = null;
	ServantActivatorStrategy servantActivator = null;
	DefaultServantHolder defaultServant = null;
	
	if(policies.requestProcessingPolicy() ==
	   org.omg.PortableServer.RequestProcessingPolicyValue.
	   USE_DEFAULT_SERVANT)
	    defaultServant = new DefaultServantHolder();
	
	if(policies.requestProcessingPolicy() ==
	   org.omg.PortableServer.RequestProcessingPolicyValue.
	   USE_SERVANT_MANAGER)
	{
	    if(policies.servantRetentionPolicy() ==
	       org.omg.PortableServer.ServantRetentionPolicyValue.RETAIN)
	    {
		servantActivator = new ServantActivatorStrategy();
	    }
	    else
	    {
		servantLocator = new ServantLocatorStrategy(orbInstance);
	    }
	}
	
	if(policies.servantRetentionPolicy() ==
	   org.omg.PortableServer.ServantRetentionPolicyValue.RETAIN)
	    return new RetainStrategy(policies, orbInstance,
				      servantActivator, defaultServant);
	// NON_RETAIN
	return new NonRetainStrategy(servantLocator, defaultServant);
    }
}
