// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package test.poa;

import java.util.*;

final public class TestMultipleOrbsThreadedClient extends test.common.TestBase
{
    public static void
    main(String args[])
    {
        Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
	          "com.ooc.CORBA.ORBSingleton");

        org.omg.CORBA.ORB orb = null;

        try
        {
	    //
	    // Create ORB
	    //
	    orb = org.omg.CORBA.ORB.init(args, props);

	    //
	    // Get test servers object references
	    //
	    org.omg.CORBA.Object obj =
	        orb.string_to_object("relfile:/Test.ref");
	    if(obj == null)
	    {
                System.err.println("TestMultipleOrbsClient: " +
                                   "cannot read IOR from Test.ref");
		System.exit(1);
	    }

	    TestServer server = TestServerHelper.narrow(obj);
	    TEST(server != null);
	    TestInfo[] info = server.get_info();

	    //
	    // Call a few methods on each object
	    //
	    for(int idx = 0 ; idx < 3 ; idx++)
	    {
	        for(int idx2 = 0 ; idx2 < info.length ; idx2++)
	        {
		    //try
		    //{
			info[idx2].obj.aMethod();
		    //}
		    //catch(org.omg.CORBA.TRANSIENT)
		    //{
		        //TODO: for now since shutdown can cause a
		        //TRANSIENT exception on the client.
		        //_OB_assert(idx == 2);
		    //}
	        }
	    }

	    //
	    // Deactivate servers
	    //
	    server.deactivate();
        }
        catch(org.omg.CORBA.SystemException ex)
        {
	    ex.printStackTrace();
	    System.exit(1);
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(org.omg.CORBA.SystemException ex)
            {
                ex.printStackTrace();
                System.exit(1);
            }
        }

        System.exit(0);
    }
}
