// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosPropertyService;

import org.omg.CosPropertyService.*;

final class PropertiesIterator_impl extends PropertiesIteratorPOA
{
    private org.omg.CORBA.ORB orb_;
    private PropertyDef[] properties_;
    private int idx_;

    PropertiesIterator_impl(org.omg.CORBA.ORB orb, PropertyDef[] properties)
    {
	orb_ = orb;
	properties_ = properties;
    }

    synchronized public void
    reset()
    {
	idx_ = 0;
    }

    synchronized public boolean
    next_one(PropertyHolder aproperty)
    {
	aproperty.value = new Property("", orb_.create_any());

	if(idx_ < properties_.length)
	{
	    aproperty.value.property_name = properties_[idx_].property_name;
	    aproperty.value.property_value = properties_[idx_].property_value;
	    idx_++;
	    return true;
	}
	else
	{
	    return false;
	}
    }

    synchronized public boolean
    next_n(int how_many, PropertiesHolder nproperties)
    {
	int len = properties_.length;
	int num = len - idx_ < how_many ? len - idx_ : how_many;

	nproperties.value = new Property[num];

	for(int i = 0 ; i < num ; i++)
	{
	    nproperties.value[i] =
		new Property(properties_[idx_].property_name,
			     properties_[idx_].property_value);
	    idx_++;
	}

	return how_many <= num;
    }

    synchronized public void
    destroy()
    {
	org.omg.PortableServer.POA poa = _poa();

	try
	{
	    byte[] oid = poa.servant_to_id(this);
	    poa.deactivate_object(oid);
	}
	catch(org.omg.PortableServer.POAPackage.WrongPolicy ex)
	{
	    throw new RuntimeException();
	}
	catch(org.omg.PortableServer.POAPackage.ServantNotActive ex)
	{
	    throw new RuntimeException();
	}
	catch(org.omg.PortableServer.POAPackage.ObjectNotActive ex)
	{
	    throw new RuntimeException();
	}
    }
}
