// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CosTime;

import org.omg.CORBA.*;
import org.omg.TimeBase.*;
import com.ooc.OB.*;

public final class TimeService
{
    // ------------------------------------------------------------------
    // TimeService initialization function
    // ------------------------------------------------------------------

    public static void
    init(ORB orb, String args[])
        throws org.omg.CORBA.ORBPackage.InvalidName
    {
	//
	// Get the set of properties
	//
	java.util.Properties properties = System.getProperties();
	com.ooc.CORBA.ORB oborb = (com.ooc.CORBA.ORB)orb;
	com.ooc.OB.Logger logger = oborb.logger();

	for(int i = 0 ; i < args.length ; i++)
	{
	    if(args[i].equals("-TIMEinaccuracy"))
	    {
		if(i + 1 >= args.length)
		{
		    logger.error("com.ooc.CosTime.TimeService.init: " +
		    		 "argument expected for -TIMEinaccuracy");
		    throw new INITIALIZE();
		}

		properties.put("ooc.time.inaccuracy", args[++i]);
	    }
	    else if(args[i].startsWith("-TIME"))
	    {
		logger.warning("com.ooc.CosTime.TimeService.init: " +
			       "unknown option: " + args[i]);
	    }
	}

	//
	// Process each property
	//
	long inaccuracy = 0;
	String propRoot = "ooc.time.";
	java.util.Enumeration keys = properties.propertyNames();
	while(keys.hasMoreElements())
	{
	    String key = (String)keys.nextElement();
	    if(!key.startsWith(propRoot))
		continue;

	    String value = properties.getProperty(key);
	    com.ooc.OB.Assert._OB_assert(value != null);

	    if(key.equals("ooc.time.inaccuracy"))
	    {
		inaccuracy = Long.valueOf(value).longValue();

		if(Unsigned.gt(inaccuracy, TimeHelper.MaxInaccuracyT))
		{
		    logger.warning("com.ooc.CosTime.TimeService.init: " +
		    		   "inaccuracy greater than maximum");
		}
	    }
	    else
	    {
		logger.warning("com.ooc.CosTime.TimeService.init: " +
			       "unknown property: " + key);
	    }
	}

	TimeService_impl service = new TimeService_impl(inaccuracy);
	((com.ooc.CORBA.ORB)orb).register_initial_reference("TimeService",
							    service);
    }
}

