// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package filetransfer;

public class Receiver
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Resolve Root POA
        //
        org.omg.PortableServer.POA rootPOA =
            org.omg.PortableServer.POAHelper.narrow(
                orb.resolve_initial_references("RootPOA"));
        org.omg.PortableServer.POAManager manager = rootPOA.the_POAManager();

        //
        // Create a child POA with a PERSISTENT and USER_ID policy
        //
        org.omg.CORBA.Policy[] policies = new org.omg.CORBA.Policy[2];
        policies[0] = rootPOA.create_lifespan_policy(
            org.omg.PortableServer.LifespanPolicyValue.PERSISTENT);
        policies[1] = rootPOA.create_id_assignment_policy(
            org.omg.PortableServer.IdAssignmentPolicyValue.USER_ID);
        org.omg.PortableServer.POA childPOA =
            rootPOA.create_POA("child", manager, policies);

        //
        // Create and activate the servant for the FileTransfer object
        //
        FileTransfer_impl filetransferImpl = new FileTransfer_impl();
        String filetransferBuf = "FileTransfer";
        byte[] oid = filetransferBuf.getBytes();
        childPOA.activate_object_with_id(oid, filetransferImpl);

        //
        // Save a reference to the Hello object
        //
        org.omg.CORBA.Object refObj = childPOA.id_to_reference(oid);

        try
        {
            String ref = orb.object_to_string(refObj);
            String refFile = "FileTransfer.ref";
            java.io.FileOutputStream file =
                new java.io.FileOutputStream(refFile);
            java.io.PrintWriter out = new java.io.PrintWriter(file);
            out.println(ref);
            out.flush();
            file.close();
        }
        catch(java.io.IOException ex)
        {
            System.err.println("Can't write to `" + ex.getMessage() + "'");
            return 1;
        }

        //
        // Run the implementation
        //
        manager.activate();
        orb.run();

        return 0;
    }

    public static void 
    main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            //
            // Create ORB
            //
            orb = org.omg.CORBA.ORB.init(args, props);

            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if(orb != null)
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
                status = 1;
            }
        }

        System.exit(status);
    }
}
