// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved  
//       
// **********************************************************************

package imageshow;

import javax.swing.*;  
import javax.swing.filechooser.*;

public class ImageFileFilter extends javax.swing.filechooser.FileFilter 
{
    //
    // Constants
    //
    private static String GIF = "gif";
    private static String JPG = "jpg";
    private static String JPEG = "jpeg";

    //
    // Determine valid directories and files
    //
    public boolean 
    accept(java.io.File file) 
    {
        if(file.isDirectory()) 
        {
            return true;
        }

        String str = file.getName();
        int i = str.lastIndexOf('.');

        if(i > 0 &&  i < str.length() - 1) 
        {
            String extn = str.substring(i + 1).toLowerCase();

            if(GIF.equals(extn) || JPG.equals(extn) || JPEG.equals(extn)) 
            {
                return true;
            } 
        }

        return false;
    }
    
    // 
    // Set Description for selection filter
    //
    public String 
    getDescription() 
    {
        return "Images (*.gif, *.jpg, *.jpeg)";
    }
}
