// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package imageshow;

public class Sender
{
    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
        //
        // Get the "ImageShow" object
        //
        org.omg.CORBA.Object obj =
            orb.string_to_object("relfile:/ImageShow.ref");
        if(obj == null)
        {
            System.err.println("imageshow.Sender: cannot read IOR from " +
                               "ImageShow.ref");
            return 1;
        }

        ImageShow imageShow = null;
        try
        {
            imageShow = ImageShowHelper.narrow(obj);
        }
        catch(org.omg.CORBA.BAD_PARAM ex)
        {
            // narrow() failed
            ex.printStackTrace();
            return 1;
        }

        //
        // Create a new sender window
        //
        new SenderWindow(imageShow, orb, args);

        return 0;
    }

    public static 
    void main(String args[])
    {
        java.util.Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass",
                  "com.ooc.CORBA.ORBSingleton");

        int status = 0;
        org.omg.CORBA.ORB orb = null;

        try
        {
            //
            // Filter the ORB command-line options
            //
            args = com.ooc.CORBA.ORB.ParseArgs(args, props, null);

            //
            // Filter the UDP command-line options
            //
            args = com.ooc.OCI.udp.parse_args(args, props);

            //
            // Create ORB
            //
            orb = org.omg.CORBA.ORB.init(args, props);

            status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
            status = 1;
        }

        if((orb != null) && (status != 0))
        {
            try
            {
                orb.destroy();
            }
            catch(Exception ex)
            {
                ex.printStackTrace();
            }

            System.exit(1);
        }
    }
}
