// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.GUI;

import com.ooc.Util.*;
import javax.swing.*;
import java.awt.*;

// Convenience methods that wrap JOptionPane
public class MessageDialog
{
    public static final int YES = 0;
    public static final int NO = 1;
    public static final int OK = 0;
    public static final int CANCEL = 1;

    private
    MessageDialog()
    {
    }

    public static void
    showError(Component comp, String message)
    {
        JOptionPane.showMessageDialog(comp, message,
                                      AppHelper.getString("ErrorTitleKey"),
                                      JOptionPane.ERROR_MESSAGE);
    }

    public static void
    showSystemError(Component comp, org.omg.CORBA.SystemException e)
    {
        e.printStackTrace();
        JOptionPane.showMessageDialog(comp,
            AppHelper.getString("SystemErrorKey"),
            AppHelper.getString("ErrorTitleKey"),
            JOptionPane.ERROR_MESSAGE);
    }

    public static void
    showWarning(Component comp, String message)
    {
	JOptionPane.showMessageDialog(comp, message,
				      AppHelper.getString("WarningTitleKey"),
				      JOptionPane.WARNING_MESSAGE);
    }

    public static void
    showInformation(Component comp, String message)
    {
	JOptionPane.showMessageDialog(comp, message,
				      AppHelper.getString("InformationTitleKey"),
				      JOptionPane.INFORMATION_MESSAGE);
    }
    

    public static int
    showConfirm(Component comp, String message)
    {
        int result;

        int i = JOptionPane.showConfirmDialog(comp, message,
            AppHelper.getString("ConfirmTitleKey"),
            JOptionPane.YES_NO_OPTION);

        if(i == JOptionPane.YES_OPTION)
            result = YES;
        else
            result = NO;

        return result;
    }
}







