// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.Util.CORBA.IOP;

//
// ProfileTagAnalyzer and its derived classes analyze an IOR profile.
// For each profile tag TAG a class of the type 'ProfileTagTAG'
// is instantiated, if available. This classes returns a string
// describing the particular profile.
//

public abstract class ProfileTagAnalyzer
{
    public abstract String analyze();

    public abstract String getIORInfo();

    protected org.omg.CORBA.portable.InputStream in_;

    void setInputStream(com.ooc.CORBA.InputStream in)
    {
	in_ = in;
    }

    //
    // Get profile analyzer for a particular profile
    //
    public static ProfileTagAnalyzer
    getAnalyzer(org.omg.IOP.TaggedProfile profile)
    {
	String analyzer = "com.ooc.Util.CORBA.IOP.ProfileTag" + profile.tag;
	try
	{
	    Class c = Class.forName(analyzer);

	    ProfileTagAnalyzer a = (ProfileTagAnalyzer)c.newInstance();
	    com.ooc.CORBA.InputStream in =
                new com.ooc.CORBA.InputStream(
                    new com.ooc.OCI.Buffer(profile.profile_data,
                                           profile.profile_data.length),
                    0, false);
            in._OB_readEndian();
	    a.setInputStream(in);
	    return a;
	}
	catch(ClassNotFoundException ex)
	{
	}
	catch(InstantiationException ex)
	{
	}
	catch(IllegalAccessException ex)
	{
	}

	return null;
    }
}
