// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.BiDir;

public class AcceptorInfo_impl extends org.omg.CORBA.LocalObject
                               implements AcceptorInfo
{
    //
    // The protocol id
    //
    private String id_;

    //
    // The profile tag
    //
    private int tag_;

    //
    // The local peer id
    //
    private String localPeer_;

    //
    // Acceptor information delegate
    //
    private com.ooc.OCI.AcceptorInfo delegate_;

    //
    // All accept callback objects
    //
    private java.util.Vector acceptCBVec_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return id_;
    }

    public int
    tag()
    {
        return tag_;
    }

    public String
    describe()
    {
        String result = id_;
        if(delegate_ == null)
            result += " callback endpoint";
        else
            result += " endpoint";
        result += "\nlocal peer: " + localPeer_;
        if(delegate_ != null)
            result += '\n' + delegate_.describe();
        return result;
    }

    public synchronized void
    add_accept_cb(com.ooc.OCI.AcceptCB cb)
    {
        int length = acceptCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(acceptCBVec_.elementAt(i) == cb)
                return; // Already registered
        acceptCBVec_.addElement(cb);
    }

    public synchronized void
    remove_accept_cb(com.ooc.OCI.AcceptCB cb)
    {
        int length = acceptCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(acceptCBVec_.elementAt(i) == cb)
            {
                acceptCBVec_.removeElementAt(i);
                return;
            }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    AcceptorInfo_impl(String id, int tag, String localPeer,
                      com.ooc.OCI.AcceptorInfo delegate)
    {
        id_ = id;
        tag_ = tag;
        localPeer_ = localPeer;
        delegate_ = delegate;
    }

    synchronized void
    _OB_callAcceptCB(com.ooc.OCI.TransportInfo info)
    {
        int length = acceptCBVec_.size();
        for(int i = 0 ; i < length ; i++)
        {
            com.ooc.OCI.AcceptCB cb =
                (com.ooc.OCI.AcceptCB)acceptCBVec_.elementAt(i);
            cb.accept_cb(info);
        }
    }
}
