// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.BiDir;

public final class Plugin_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.Plugin
{
    private org.omg.CORBA.ORB orb_; // The ORB
    private String peer_; // The peer id

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return "bidir";
    }

    public int
    tag()
    {
        throw new org.omg.CORBA.NO_IMPLEMENT(); // TODO: Change this?
    }

    public void
    init_client(String[] params)
    {
        String protocol = null;

        int i = 0;
        while(i < params.length)
        {
            if(params[i].equals("--protocol"))
            {
                if(i + 1 == params.length)
                    throw new org.omg.CORBA.INITIALIZE("bidir: argument " +
                                                       "expected for " +
                                                       "--protocol");

                protocol = params[i + 1];

                i += 2;
            }
            else
            {
                throw new org.omg.CORBA.INITIALIZE("bidir: unknown client " +
                                                   "parameter `" + params[i] +
                                                   "'");
            }
        }

        if(protocol == null)
            throw new org.omg.CORBA.INITIALIZE("bidir: no protocol specified");

        String id = "bidir_" + protocol;

        try
        {
            org.omg.CORBA.Object obj = null;
            TransportManager transportManager = null;

            //
            // See if an acceptor factory already exists for this protocol.
            // If so, get the transport manager from it.
            //
            {
                obj = orb_.resolve_initial_references("OCIAccFactoryRegistry");
                com.ooc.OCI.AccFactoryRegistry registry =
                    com.ooc.OCI.AccFactoryRegistryHelper.narrow(obj);
                com.ooc.OB.Assert._OB_assert(registry != null);
                com.ooc.OCI.AccFactory[] factories = registry.get_factories();
                for(i = 0 ; i < factories.length ; i++)
                {
                    if(id.equals(factories[i].id()))
                    {
                        AccFactory_impl impl = (AccFactory_impl)factories[i];
                        transportManager = impl._OB_transportManager();
                        break;
                    }
                }
            }

            obj = orb_.resolve_initial_references("OCIConFactoryRegistry");
            com.ooc.OCI.ConFactoryRegistry registry =
                com.ooc.OCI.ConFactoryRegistryHelper.narrow(obj);
            com.ooc.OCI.ConFactory[] factories = registry.get_factories();
            for(i = 0 ; i < factories.length ; i++)
                if(protocol.equals(factories[i].id()))
                    break;
            if(i == factories.length)
                throw new org.omg.CORBA.INITIALIZE("bidir: protocol `" +
                                                   protocol + "' not found");
            int tag;
            if(transportManager == null)
            {
                tag = factories[i].tag() | 1024;
                transportManager = new TransportManager(id, tag, peer_);
            }
            else
                tag = transportManager.tag();
            registry.add_factory(new ConFactory_impl(factories[i],
                                                     transportManager));

            //
            // Install the corbaloc URL protocol
            //
            obj = orb_.resolve_initial_references("URLRegistry");
            com.ooc.OB.URLRegistry urlRegistry =
                com.ooc.OB.URLRegistryHelper.narrow(obj);
            com.ooc.OB.URLScheme scheme = urlRegistry.find_scheme("corbaloc");
            com.ooc.OB.Assert._OB_assert(scheme != null);
            com.ooc.OB.CorbalocURLScheme corbaloc =
                com.ooc.OB.CorbalocURLSchemeHelper.narrow(scheme);
            com.ooc.OB.CorbalocProtocol p = corbaloc.find_protocol(protocol);
            if(p != null)
                corbaloc.add_protocol(new CorbalocProtocol_impl(id, tag, p));
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OCI.FactoryAlreadyExists ex)
        {
            throw new org.omg.CORBA.INITIALIZE("bidir: plug-in already " +
                                               "installed for protocol `" +
                                               protocol + "'");
        }
        catch(com.ooc.OB.CorbalocURLSchemePackage.ProtocolAlreadyExists ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
    }

    public void
    init_server(String[] params)
    {
        String protocol = null;

        int i = 0;
        while(i < params.length)
        {
            if(params[i].equals("--protocol"))
            {
                if(i + 1 == params.length)
                    throw new org.omg.CORBA.INITIALIZE("bidir: argument " +
                                                       "expected for " +
                                                       "--protocol");

                protocol = params[i + 1];

                i += 2;
            }
            else
            {
                throw new org.omg.CORBA.INITIALIZE("bidir: unknown server " +
                                                   "parameter `" + params[i] +
                                                   "'");
            }
        }

        if(protocol == null)
            throw new org.omg.CORBA.INITIALIZE("bidir: no protocol specified");

        String id = "bidir_" + protocol;

        try
        {
            org.omg.CORBA.Object obj = null;
            TransportManager transportManager = null;

            //
            // See if a connector factory already exists for this protocol.
            // If so, get the transport manager from it.
            //
            {
                obj = orb_.resolve_initial_references("OCIConFactoryRegistry");
                com.ooc.OCI.ConFactoryRegistry registry =
                    com.ooc.OCI.ConFactoryRegistryHelper.narrow(obj);
                com.ooc.OB.Assert._OB_assert(registry != null);
                com.ooc.OCI.ConFactory[] factories = registry.get_factories();
                for(i = 0 ; i < factories.length ; i++)
                {
                    if(id.equals(factories[i].id()))
                    {
                        ConFactory_impl impl = (ConFactory_impl)factories[i];
                        transportManager = impl._OB_transportManager();
                        break;
                    }
                }
            }

            obj = orb_.resolve_initial_references("OCIAccFactoryRegistry");
            com.ooc.OCI.AccFactoryRegistry registry =
                com.ooc.OCI.AccFactoryRegistryHelper.narrow(obj);
            com.ooc.OCI.AccFactory[] factories = registry.get_factories();
            for(i = 0 ; i < factories.length ; i++)
                if(protocol.equals(factories[i].id()))
                    break;
            if(i == factories.length)
                throw new org.omg.CORBA.INITIALIZE("bidir: protocol `" +
                                                   protocol + "' not found");
            if(transportManager == null)
            {
                int tag = factories[i].tag() | 1024;
                transportManager = new TransportManager(id, tag, peer_);
            }
            registry.add_factory(new AccFactory_impl(factories[i],
                                                     transportManager));
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OCI.FactoryAlreadyExists ex)
        {
            throw new org.omg.CORBA.INITIALIZE("bidir: plug-in already " +
                                               "installed for protocol `" +
                                               protocol + "'");
        }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public
    Plugin_impl(org.omg.CORBA.ORB orb, String peer)
    {
        orb_ = orb;
        peer_ = peer;
    }
}
