// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.BiDir;

//
// SelfTransport_impl is used only for "self connections" to an Acceptor
// with no delegate. All relevant operations will block until close() is
// invoked.
//
public class SelfTransport_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.Transport
{
    //
    // The transport info
    //
    private SelfTransportInfo_impl info_;

    //
    // Have we been closed?
    //
    private boolean closed_;

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        com.ooc.OB.Assert._OB_assert(false);
        return null; // to satisfy the compiler
    }

    public int
    tag()
    {
        com.ooc.OB.Assert._OB_assert(false);
        return 0; // to satisfy the compiler
    }

    public com.ooc.OCI.SendReceiveMode
    mode()
    {
        return com.ooc.OCI.SendReceiveMode.SendReceive;
    }

    public int
    handle()
    {
        throw new org.omg.CORBA.NO_IMPLEMENT();
    }

    public synchronized void
    close()
    {
        closed_ = true;
        notifyAll();
    }

    public void
    shutdown()
    {
        //
        // Nothing to do
        //
    }

    public synchronized void
    receive(com.ooc.OCI.Buffer buf, boolean block)
    {
        if(block)
        {
            while(!closed_)
            {
                try
                {
                    wait();
                }
                catch(InterruptedException ex)
                {
                }
            }
        }

        if(closed_)
            throw new org.omg.CORBA.COMM_FAILURE();
    }

    public synchronized boolean
    receive_detect(com.ooc.OCI.Buffer buf, boolean block)
    {
        if(block)
        {
            while(!closed_)
            {
                try
                {
                    wait();
                }
                catch(InterruptedException ex)
                {
                }
            }
        }

        return !closed_;
    }

    public synchronized void
    receive_timeout(com.ooc.OCI.Buffer buf, int timeout)
    {
        try
        {
            wait(timeout);
        }
        catch(InterruptedException ex)
        {
        }

        if(closed_)
            throw new org.omg.CORBA.COMM_FAILURE();
    }

    public synchronized boolean
    receive_timeout_detect(com.ooc.OCI.Buffer buf, int timeout)
    {
        try
        {
            wait(timeout);
        }
        catch(InterruptedException ex)
        {
        }

        return !closed_;
    }

    public synchronized void
    send(com.ooc.OCI.Buffer buf, boolean block)
    {
        if(block)
        {
            while(!closed_)
            {
                try
                {
                    wait();
                }
                catch(InterruptedException ex)
                {
                }
            }
        }
    }

    public synchronized boolean
    send_detect(com.ooc.OCI.Buffer buf, boolean block)
    {
        if(block)
        {
            while(!closed_)
            {
                try
                {
                    wait();
                }
                catch(InterruptedException ex)
                {
                }
            }
        }

        return !closed_;
    }

    public synchronized void
    send_timeout(com.ooc.OCI.Buffer buf, int timeout)
    {
        try
        {
            wait(timeout);
        }
        catch(InterruptedException ex)
        {
        }

        if(closed_)
            throw new org.omg.CORBA.COMM_FAILURE();
    }

    public synchronized boolean
    send_timeout_detect(com.ooc.OCI.Buffer buf, int timeout)
    {
        try
        {
            wait(timeout);
        }
        catch(InterruptedException ex)
        {
        }

        return !closed_;
    }

    public com.ooc.OCI.TransportInfo
    get_info()
    {
        return info_;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    SelfTransport_impl()
    {
        info_ = new SelfTransportInfo_impl();
        closed_ = false;
    }
}
