// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.BiDir;

public class TransportInfo_impl extends org.omg.CORBA.LocalObject
                                implements TransportInfo
{
    //
    // The protocol id
    //
    private String id_;

    //
    // The profile tag
    //
    private int tag_;

    //
    // The local peer id
    //
    private String localPeer_;

    //
    // The remote peer id
    //
    private String remotePeer_;

    //
    // Connector information
    //
    private com.ooc.OCI.ConnectorInfo connectorInfo_;

    //
    // Acceptor information
    //
    private com.ooc.OCI.AcceptorInfo acceptorInfo_;

    //
    // The Transport information delegate
    //
    private com.ooc.OCI.TransportInfo delegate_;

    //
    // All close callback objects
    //
    private java.util.Vector closeCBVec_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return id_;
    }

    public int
    tag()
    {
        return tag_;
    }

    public com.ooc.OCI.ConnectorInfo
    connector_info()
    {
        return connectorInfo_;
    }

    public com.ooc.OCI.AcceptorInfo
    acceptor_info()
    {
        return acceptorInfo_;
    }

    public String
    describe()
    {
        String result = id_ + " transport" +
                        "\nlocal peer: " + localPeer_ +
                        "\nremote peer: " + remotePeer_ +
                        '\n' + delegate_.describe();
        return result;
    }

    public synchronized void
    add_close_cb(com.ooc.OCI.CloseCB cb)
    {
        int length = closeCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(closeCBVec_.elementAt(i) == cb)
                return; // Already registered
        closeCBVec_.addElement(cb);
    }

    public synchronized void
    remove_close_cb(com.ooc.OCI.CloseCB cb)
    {
        int length = closeCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(closeCBVec_.elementAt(i) == cb)
            {
                closeCBVec_.removeElementAt(i);
                return;
            }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    TransportInfo_impl(String id, int tag, String localPeer, String remotePeer,
                       com.ooc.OCI.Connector connector,
                       com.ooc.OCI.TransportInfo delegate)
    {
        id_ = id;
        tag_ = tag;
        localPeer_ = localPeer;
        remotePeer_ = remotePeer;
        connectorInfo_ = connector.get_info();
        delegate_ = delegate;
    }

    TransportInfo_impl(String id, int tag, String localPeer, String remotePeer,
                       com.ooc.OCI.Acceptor acceptor,
                       com.ooc.OCI.TransportInfo delegate)
    {
        id_ = id;
        tag_ = tag;
        localPeer_ = localPeer;
        remotePeer_ = remotePeer;
        acceptorInfo_ = acceptor.get_info();
        delegate_ = delegate;
    }

    synchronized void
    _OB_callCloseCB(com.ooc.OCI.TransportInfo info)
    {
        int length = closeCBVec_.size();
        for(int i = 0 ; i < length ; i++)
        {
            com.ooc.OCI.CloseCB cb =
                (com.ooc.OCI.CloseCB)closeCBVec_.elementAt(i);
            cb.close_cb(info);
        }
    }
}
