// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package hello;

public class Server
{
    //
    // The close callback class
    //
    static class CloseCB_impl extends org.omg.CORBA.LocalObject
        implements com.ooc.OCI.CloseCB
    {
        public void
        close_cb(com.ooc.OCI.TransportInfo transport_info)
        {
            com.ooc.OCI.IIOP.TransportInfo iiopInfo =
                com.ooc.OCI.IIOP.TransportInfoHelper.narrow(transport_info);

            if(iiopInfo != null)
            {
                int[] remoteAddr = Converter.addr(iiopInfo.remote_addr());
                int remotePort = Converter.port(iiopInfo.remote_port());

                System.out.println("Close connection from: " +
                                   remoteAddr[0] + "." +
                                   remoteAddr[1] + "." +
                                   remoteAddr[2] + "." +
                                   remoteAddr[3] + ":" + remotePort);
            }
        }
    }

    //
    // The accept callback class
    //
    static class AcceptCB_impl extends org.omg.CORBA.LocalObject
        implements com.ooc.OCI.AcceptCB
    {
        public void
        accept_cb(com.ooc.OCI.TransportInfo transport_info)
        {
            com.ooc.OCI.IIOP.TransportInfo iiopInfo =
                com.ooc.OCI.IIOP.TransportInfoHelper.narrow(transport_info);

            if(iiopInfo != null)
            {
                int[] remoteAddr = Converter.addr(iiopInfo.remote_addr());
                int remotePort = Converter.port(iiopInfo.remote_port());

                System.out.println("Connection from: " +
                                   remoteAddr[0] + "." +
                                   remoteAddr[1] + "." +
                                   remoteAddr[2] + "." +
                                   remoteAddr[3] + ":" + remotePort);

                String input = null;
                do
                {
                    System.out.print("Refuse connection (y/n)? ");
                    java.io.BufferedReader in =
                        new java.io.BufferedReader(
                            new java.io.InputStreamReader(System.in));
                    try
                    {
                        input = in.readLine();
                    }
                    catch(java.io.IOException ex)
                    {
                    }
                }
                while(!input.equals("y") && !input.equals("n"));

                if(input.equals("y"))
                    throw new org.omg.CORBA.NO_PERMISSION();

                //
                // Add the close callback object
                //
                com.ooc.OCI.CloseCB closeCB = new CloseCB_impl();
                iiopInfo.add_close_cb(closeCB);
            }
        }
    }

    static int
    run(org.omg.CORBA.ORB orb, String[] args)
        throws org.omg.CORBA.UserException
    {
	//
	// Resolve Root POA
	//
	org.omg.PortableServer.POA root =
	    org.omg.PortableServer.POAHelper.narrow(
		orb.resolve_initial_references("RootPOA"));

	org.omg.PortableServer.POAManager manager = root.the_POAManager();

	//
	// Get the OCI Current object
	//
	com.ooc.OCI.Current current =
	    com.ooc.OCI.CurrentHelper.narrow(
		orb.resolve_initial_references("OCICurrent"));

	//
	// Create implementation object
	//
	Hello_impl helloImpl = new Hello_impl(current);
	Hello p = helloImpl._this(orb);

	//
	// Save reference
	//
	try
	{
	    String ref = orb.object_to_string(p);
	    String refFile = "Hello.ref";
	    java.io.FileOutputStream file =
		new java.io.FileOutputStream(refFile);
	    java.io.PrintWriter out = new java.io.PrintWriter(file);
	    out.println(ref);
	    out.flush();
	    file.close();
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("hello.Server: can't write to `" +
                               ex.getMessage() + "'");
	    return 1;
	}

	//
	// Save reference as html
	//
	try
	{
	    String ref = orb.object_to_string(p);
	    String refFile = "Hello.html";
	    java.io.FileOutputStream file =
		new java.io.FileOutputStream(refFile);
	    java.io.PrintWriter out = new java.io.PrintWriter(file);
	    out.println("<applet codebase=\"classes\" " +
			"code=\"hello/Client.class\" " +
			"archive=\"OB.jar\" " +
			"width=500 height=300>");
	    out.println("<param name=ior value=\"" + ref + "\">");
	    out.println("<param name=org.omg.CORBA.ORBClass " +
			"value=com.ooc.CORBA.ORB>");
            //
            // No need to specify ORBSingletonClass - it's ignored anyway
            //
            //out.println("<param name=org.omg.CORBA.ORBSingletonClass " +
            //            "value=com.ooc.CORBA.ORBSingleton>");
	    out.println("</applet>");
	    out.flush();
	    file.close();
	}
	catch(java.io.IOException ex)
	{
	    System.err.println("hello.Server: can't write to `" +
			       ex.getMessage() + "'");
	    return 1;
	}

	//
	// Display the host and port
	//
	com.ooc.OBPortableServer.POAManager obManager =
	    com.ooc.OBPortableServer.POAManagerHelper.narrow(manager);
	com.ooc.OCI.Acceptor[] acceptors = obManager.get_acceptors();

	for(int i = 0 ; i < acceptors.length ; i++)
	{
	    com.ooc.OCI.AcceptorInfo info = acceptors[i].get_info();
	    com.ooc.OCI.IIOP.AcceptorInfo iiopInfo =
		com.ooc.OCI.IIOP.AcceptorInfoHelper.narrow(info);

	    if(iiopInfo != null)
	    {
		String[] hosts = iiopInfo.hosts();
		int port = Converter.port(iiopInfo.port());
		
		System.out.println("*** Running on host `" + hosts[0] +
				   "', port number " + port);

		//
		// Add the accept callback object
		//
		com.ooc.OCI.AcceptCB acceptorCB = new AcceptCB_impl();
		iiopInfo.add_accept_cb(acceptorCB);
	    }
	}

	//
	// Run implementation
	//
        manager.activate();
	orb.run();

	return 0;
    }

    public static void
    main(String args[])
    {
	java.util.Properties props = System.getProperties();
	props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
	props.put("org.omg.CORBA.ORBSingletonClass",
		  "com.ooc.CORBA.ORBSingleton");

	int status = 0;
	org.omg.CORBA.ORB orb = null;

        try
        {
            orb = org.omg.CORBA.ORB.init(args, props);
	    status = run(orb, args);
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
	    status = 1;
        }

  	if(orb != null)
	{
	    try
	    {
		orb.destroy();
	    }
	    catch(Exception ex)
	    {
                ex.printStackTrace();
                status = 1;
	    }
	}

        System.exit(status);
    }
}
