// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package pi;

//
// ORB Initializer for the server and client request interceptors
//
final public class RIORBInitializer_impl extends org.omg.CORBA.LocalObject
    implements org.omg.PortableInterceptor.ORBInitializer
{
    // -----------------------------------------------------------------
    // IDL to Java Mapping
    // -----------------------------------------------------------------

    public void
    pre_init(org.omg.PortableInterceptor.ORBInitInfo info)
    {
    }

    //
    // Note: the interceptors are registered in post_init()
    //       because the CRILogger_impl and SRILogger_impl
    //       constructors require
    //       ORBInitInfo::resolve_initial_reference(), which
    //       cannot be called in pre_init().
    //
    public void
    post_init(org.omg.PortableInterceptor.ORBInitInfo info)
    {
	//
	// Register the policy factory
	//
	org.omg.PortableInterceptor.PolicyFactory pf =
	    new LoggerPolicyFactory_impl();
	info.register_policy_factory(LOGGER_POLICY_ID.value, pf);

	//
	// Allocate state slot for call stack tracing
	//
	int slotId = info.allocate_slot_id();

	//
	// Create the interceptors
	//
	org.omg.PortableInterceptor.ClientRequestInterceptor
	    clientInterceptor = new CRILogger_impl(info, slotId);
	org.omg.PortableInterceptor.ServerRequestInterceptor
	    serverInterceptor = new SRILogger_impl(info, slotId);

	//
	// Register the interceptors
	//
	try
	{
	    info.add_client_request_interceptor(clientInterceptor);
	    info.add_server_request_interceptor(serverInterceptor);
	}
	catch(org.omg.PortableInterceptor.ORBInitInfoPackage.DuplicateName ex)
	{
	    throw new RuntimeException();
	}
    }
}
