// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.CORBA;

final public class ORBPolicyManager_impl extends org.omg.CORBA.LocalObject
    implements org.omg.CORBA.PolicyManager
{
    //
    // Vector is owned by OBORB_impl - do not use Policy[]
    //
    private java.util.Vector policies_;

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------    

    public synchronized org.omg.CORBA.Policy
    get_policy_override(int policy_type)
    {
        java.util.Enumeration e = policies_.elements();
        while(e.hasMoreElements())
        {
            org.omg.CORBA.Policy p = (org.omg.CORBA.Policy)e.nextElement();
            if(p.policy_type() == policy_type)
                return p;
        }
        return null;
    }

    public synchronized org.omg.CORBA.Policy[]
    get_specific_policy_overrides(int[] types)
    {
        int typesLen = types.length;

        java.util.Vector policies = new java.util.Vector();

        for(int i = 0 ; i < typesLen ; i++)
        {
            int currType = types[i];
            java.util.Enumeration e = policies_.elements();
            while(e.hasMoreElements())
            {
                org.omg.CORBA.Policy p = (org.omg.CORBA.Policy)e.nextElement();
                if(p.policy_type() == currType)
                    policies.addElement(p);
            }
        }
        org.omg.CORBA.Policy[] result =
            new org.omg.CORBA.Policy[policies.size()];
        policies.copyInto(result);
        return result;
    }

    public synchronized org.omg.CORBA.Policy[]
    get_all_policy_overrides()
    {
        org.omg.CORBA.Policy[] result =
            new org.omg.CORBA.Policy[policies_.size()];
        policies_.copyInto(result);
        return result;
    }

    public synchronized void
    add_policy_overrides(org.omg.CORBA.Policy[] np)
         throws org.omg.CORBA.PolicyManagerPackage.InvalidPolicies
    {
        java.util.Vector newPolicies = (java.util.Vector)policies_.clone();

        int npLen = np.length;
        for(int i = 0 ; i < npLen ; i++)
        {
            int len = newPolicies.size();
            int j;

            for(j = 0 ; j < len ; j++)
            {
                org.omg.CORBA.Policy p =
                    (org.omg.CORBA.Policy)newPolicies.elementAt(j);
                if(p.policy_type() == np[i].policy_type())
                    break;
            }

            if(j < len)
                newPolicies.setElementAt(np[i], j);
            else
                newPolicies.addElement(np[i]);
        }

        org.omg.CORBA.Policy[] arr =
            new org.omg.CORBA.Policy[newPolicies.size()];
        newPolicies.copyInto(arr);

        policies_ = newPolicies;
    }

    public synchronized void
    remove_policy_overrides(int[] ts)
    {
        int typesLen = ts.length;

        for(int i = 0 ; i < typesLen ; i++)
        {
            int currType = ts[i];
            int len = policies_.size();
            for(int j = 0 ; j < len ; j++)
            {
                org.omg.CORBA.Policy p =
                    (org.omg.CORBA.Policy)policies_.elementAt(j);
                if(p.policy_type() == currType)
                {
                    policies_.removeElementAt(j);
                    break;
                }
            }
        }
    }

    public synchronized void
    replace_all_policy_overrides(org.omg.CORBA.Policy[] policies)
         throws org.omg.CORBA.PolicyManagerPackage.InvalidPolicies
    {
        policies_.removeAllElements();
        for(int i = 0 ; i < policies.length ; i++)
            policies_.addElement(policies[i]);
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public ORBPolicyManager_impl(java.util.Vector policies)
    {
        policies_ = policies;
    }
}
