// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.IIOP;

final class AcceptorInfo_impl extends org.omg.CORBA.LocalObject
    implements AcceptorInfo
{
    private Acceptor_impl acceptor_; // The associated acceptor

    //
    // All accept callback objects
    //
    private java.util.Vector acceptCBVec_ = new java.util.Vector();

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return PLUGIN_ID.value;
    }

    public int
    tag()
    {
        return org.omg.IOP.TAG_INTERNET_IOP.value;
    }

    public synchronized String
    describe()
    {
        String desc = "id: " + PLUGIN_ID.value;

        byte[] localAddr = addr();
        short localPort = port();
        desc += "\nlocal address: ";
        desc += (localAddr[0] < 0 ? 0xff + (int)localAddr[0] + 1
                                  : localAddr[0]);
        desc += ".";
        desc += (localAddr[1] < 0 ? 0xff + (int)localAddr[1] + 1
                                  : localAddr[1]);
        desc += ".";
        desc += (localAddr[2] < 0 ? 0xff + (int)localAddr[2] + 1
                                  : localAddr[2]);
        desc += ".";
        desc += (localAddr[3] < 0 ? 0xff + (int)localAddr[3] + 1
                                  : localAddr[3]);
        desc += ":";
        desc += (localPort < 0 ? 0xffff + (int)localPort + 1 : localPort);

        desc += "\nhosts: ";
        String[] hostNames = hosts();
        for(int i = 0 ; i < hostNames.length ; i++)
        {
            if(i > 0)
                desc += ", ";
            desc += hostNames[i];
        }

        return desc;
    }

    public synchronized void
    add_accept_cb(com.ooc.OCI.AcceptCB cb)
    {
        int length = acceptCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(acceptCBVec_.elementAt(i) == cb)
                return; // Already registered
        acceptCBVec_.addElement(cb);
    }

    public synchronized void
    remove_accept_cb(com.ooc.OCI.AcceptCB cb)
    {
        int length = acceptCBVec_.size();
        for(int i = 0 ; i < length ; i++)
            if(acceptCBVec_.elementAt(i) == cb)
            {
                acceptCBVec_.removeElementAt(i);
                return;
            }
    }

    public synchronized String[]
    hosts()
    {
	if(acceptor_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES();

        return acceptor_.hosts_;
    }

    public synchronized byte[]
    addr()
    {
	if(acceptor_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES();

        return acceptor_.socket_.getInetAddress().getAddress();
    }

    public synchronized short
    port()
    {
	if(acceptor_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES();

	int port = acceptor_.socket_.getLocalPort();

	if(port >= 0x8000)
	    return (short)(port - 0xffff - 1);
	else
	    return (short)port;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    AcceptorInfo_impl(Acceptor_impl acceptor)
    {
        acceptor_ = acceptor;
    }

    synchronized void
    _OB_callAcceptCB(com.ooc.OCI.TransportInfo info)
    {
        int length = acceptCBVec_.size();
        for(int i = 0 ; i < length ; i++)
        {
            com.ooc.OCI.AcceptCB cb =
                (com.ooc.OCI.AcceptCB)acceptCBVec_.elementAt(i);
            cb.accept_cb(info);
        }
    }

    synchronized void
    _OB_destroy()
    {
	acceptor_ = null;
    }
}
