// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.UDP;

final class ClientTransportInfo_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.UDP.TransportInfo
{
    //
    // The transport
    //
    private ClientTransport_impl transport_;

    //
    // The connector info
    //
    private com.ooc.OCI.ConnectorInfo connectorInfo_;

    //
    // All close callback objects
    //
    private java.util.Vector closeCBs_ = new java.util.Vector();
    
    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return PLUGIN_ID.value;
    }

    public int
    tag()
    {
        return com.ooc.UDPIOP.TAG_UDP_IOP.value;
    }

    public synchronized String
    describe()
    {
        String desc = "id: " + PLUGIN_ID.value;

        byte[] localAddr = addr();
        short localPort = port();
        desc += "\nlocal address: ";
        desc += (localAddr[0] < 0 ? 0xff + (int)localAddr[0] + 1
                                  : localAddr[0]);
        desc += ".";
        desc += (localAddr[1] < 0 ? 0xff + (int)localAddr[1] + 1
                                  : localAddr[1]);
        desc += ".";
        desc += (localAddr[2] < 0 ? 0xff + (int)localAddr[2] + 1
                                  : localAddr[2]);
        desc += ".";
        desc += (localAddr[3] < 0 ? 0xff + (int)localAddr[3] + 1
                                  : localAddr[3]);
        desc += ":";
        desc += (localPort < 0 ? 0xffff + (int)localPort + 1 : localPort);

        byte[] remoteAddr = remote_addr();
        short remotePort = remote_port();
        desc += "\nremote address: ";
        desc += (remoteAddr[0] < 0 ? 0xff + (int)remoteAddr[0] + 1
                                   : remoteAddr[0]);
        desc += ".";
        desc += (remoteAddr[1] < 0 ? 0xff + (int)remoteAddr[1] + 1
                                   : remoteAddr[1]);
        desc += ".";
        desc += (remoteAddr[2] < 0 ? 0xff + (int)remoteAddr[2] + 1
                                   : remoteAddr[2]);
        desc += ".";
        desc += (remoteAddr[3] < 0 ? 0xff + (int)remoteAddr[3] + 1
                                   : remoteAddr[3]);
        desc += ":";
        desc += (remotePort < 0 ? 0xffff + (int)remotePort + 1 : remotePort);

        return desc;
    }

    public com.ooc.OCI.ConnectorInfo
    connector_info()
    {
        return connectorInfo_;
    }
    
    public com.ooc.OCI.AcceptorInfo
    acceptor_info()
    {
        return null;
    }

    public synchronized void
    add_close_cb(com.ooc.OCI.CloseCB cb)
    {
        int length = closeCBs_.size();
        for(int i = 0; i < length; i++)
            if(closeCBs_.elementAt(i) == cb)
                return; // Already registered
        closeCBs_.addElement(cb);
    }

    public synchronized void
    remove_close_cb(com.ooc.OCI.CloseCB cb)
    {
        int length = closeCBs_.size();
        for(int i = 0; i < length; i++)
            if(closeCBs_.elementAt(i) == cb)
            {
                closeCBs_.removeElementAt(i);
                return;
            }
    }

    public synchronized byte[]
    addr()
    {
	if(transport_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES();

        return transport_.fd_.getLocalAddress().getAddress();
    }

    public synchronized short
    port()
    {
	if(transport_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES();

        int port = transport_.fd_.getLocalPort();

	if(port >= 0x8000)
	    return (short)(port - 0xffff - 1);
	else
	    return (short)port;
    }

    public synchronized byte[]
    remote_addr()
    {
	if(transport_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES();

        return transport_.fd_.getInetAddress().getAddress();
    }

    public synchronized short
    remote_port()
    {
	if(transport_ == null)
	    throw new org.omg.CORBA.NO_RESOURCES();

        int port = transport_.fd_.getPort();

        if(port >= 0x8000)
            return (short)(port - 0xffff - 1);
        else
            return (short)port;
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    ClientTransportInfo_impl(ClientTransport_impl transport,
                             com.ooc.OCI.Connector connector)
    {
        transport_ = transport;
        connectorInfo_ = connector.get_info();
    }

    synchronized void
    _OB_callCloseCB(com.ooc.OCI.TransportInfo info)
    {
        int length = closeCBs_.size();
        for(int i = 0; i < length; i++)
        {
            com.ooc.OCI.CloseCB cb =
                (com.ooc.OCI.CloseCB)closeCBs_.elementAt(i);
            cb.close_cb(info);
        }
    }

    synchronized void
    _OB_destroy()
    {
        transport_ = null;
    }
}
