// **********************************************************************
//
// Copyright (c) 2002
// IONA Technologies, Inc.
// Waltham, MA, USA
//
// All Rights Reserved
//
// **********************************************************************

package com.ooc.OCI.UDP;

public final class Plugin_impl extends org.omg.CORBA.LocalObject
    implements com.ooc.OCI.Plugin
{
    private org.omg.CORBA.ORB orb_; // The ORB

    // ------------------------------------------------------------------
    // Standard IDL to Java Mapping
    // ------------------------------------------------------------------

    public String
    id()
    {
        return PLUGIN_ID.value;
    }

    public int
    tag()
    {
        return com.ooc.UDPIOP.TAG_UDP_IOP.value;
    }

    public void
    init_client(String[] params)
    {
        int bufferSize = 0;
        int packetDelay = 2;
        int packetSize = 1472; // 1472 is the largest portable datagram size
        int trace = 0;
	boolean noLoopback = false;
	int ttl = -1;

        int i = 0;
        while(i < params.length)
        {
            if(params[i].equals("--buffer-size"))
            {
                if(i + 1 == params.length)
                    throw new org.omg.CORBA.INITIALIZE("udp: argument " +
                                                       "expected for " +
                                                       "--buffer-size");

                try
                {
                    bufferSize = Integer.valueOf(params[i + 1]).intValue();
                }
                catch(NumberFormatException ex)
                {
                    throw new org.omg.CORBA.INITIALIZE("udp: invalid " +
                                                       "argument for " +
                                                       "--buffer-size");
                }
                if(bufferSize < 0)
                    bufferSize = 0;

                i += 2;
            }
            else if(params[i].equals("--packet-delay"))
            {
                if(i + 1 == params.length)
                    throw new org.omg.CORBA.INITIALIZE("udp: argument " +
                                                       "expected for " +
                                                       "--packet-delay");

                try
                {
                    packetDelay = Integer.valueOf(params[i + 1]).intValue();
                }
                catch(NumberFormatException ex)
                {
                    throw new org.omg.CORBA.INITIALIZE("udp: invalid " +
                                                       "argument for " +
                                                       "--packet-delay");
                }
                if(packetDelay < 0)
                    packetDelay = 0;

                i += 2;
            }
            else if(params[i].equals("--packet-size"))
            {
                if(i + 1 == params.length)
                    throw new org.omg.CORBA.INITIALIZE("udp: argument " +
                                                       "expected for " +
                                                       "--packet-size");

                try
                {
                    packetSize = Integer.valueOf(params[i + 1]).intValue();
                }
                catch(NumberFormatException ex)
                {
                    throw new org.omg.CORBA.INITIALIZE("udp: invalid " +
                                                       "argument for " +
                                                       "--packet-size");
                }
                if(packetDelay < 100)
                    packetDelay = 100;

                i += 2;
            }
            else if(params[i].equals("--trace"))
            {
                if(i + 1 == params.length)
                    throw new org.omg.CORBA.INITIALIZE("udp: argument " +
                                                       "expected for " +
                                                       "--trace");

                try
                {
                    trace = Integer.valueOf(params[i + 1]).intValue();
                }
                catch(NumberFormatException ex)
                {
                    throw new org.omg.CORBA.INITIALIZE("udp: invalid " +
                                                       "argument for " +
                                                       "--trace");
                }
                if(trace < 0)
                    trace = 0;

                i += 2;
            }
            else if(params[i].equals("--no-loopback"))
            {
                noLoopback = true;
                i++;
            }
            else if(params[i].equals("--ttl"))
            {
                if(i + 1 >= params.length)
                    throw new org.omg.CORBA.INITIALIZE("udp: argument " +
						       "expected for " +
                                                       "--ttl");
                try
                {
                    ttl = Integer.valueOf(params[i + 1]).intValue();
                }
                catch(NumberFormatException ex)
                {
                    throw new org.omg.CORBA.INITIALIZE("udp: invalid " +
						       " argument for " +
						       "--ttl");
                }
                if(ttl < 0 || ttl > 255)
                    throw new org.omg.CORBA.INITIALIZE("udp: ttl must be " + 
						       "between 0 and 255");
                i += 2;
            }
            else
            {
                throw new org.omg.CORBA.INITIALIZE("udp: unknown client " +
                                                   "parameter `" + params[i] +
                                                   "'");
            }
        }

        //
        // Install the ConFactory
        //
        try
        {
            org.omg.CORBA.Object obj =
                orb_.resolve_initial_references("OCIConFactoryRegistry");
            com.ooc.OCI.ConFactoryRegistry registry =
                com.ooc.OCI.ConFactoryRegistryHelper.narrow(obj);
            com.ooc.OB.Logger logger = ((com.ooc.CORBA.ORB)orb_).logger();
            registry.add_factory(new ConFactory_impl(trace, bufferSize,
                                                     packetSize, packetDelay,
						     noLoopback, ttl,
                                                     logger));
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OCI.FactoryAlreadyExists ex)
        {
            throw new org.omg.CORBA.INITIALIZE("udp: plug-in already " +
                                               "installed");
        }

        //
        // Install the "udp" corbaloc URL protocol
        //
        try
        {
            org.omg.CORBA.Object obj =
                orb_.resolve_initial_references("URLRegistry");
            com.ooc.OB.URLRegistry registry =
                com.ooc.OB.URLRegistryHelper.narrow(obj);
            com.ooc.OB.URLScheme scheme = registry.find_scheme("corbaloc");
            com.ooc.OB.Assert._OB_assert(scheme != null);
            com.ooc.OB.CorbalocURLScheme corbaloc =
                com.ooc.OB.CorbalocURLSchemeHelper.narrow(scheme);
            corbaloc.add_protocol(new CorbalocProtocol_impl());
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OB.CorbalocURLSchemePackage.ProtocolAlreadyExists ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
    }

    public void
    init_server(String[] params)
    {
        int trace = 0;

        int i = 0;
        while(i < params.length)
        {
            if(params[i].equals("--trace"))
            {
                if(i + 1 == params.length)
                    throw new org.omg.CORBA.INITIALIZE("udp: argument " +
                                                       "expected for " +
                                                       "--trace");

                try
                {
                    trace = Integer.valueOf(params[i + 1]).intValue();
                }
                catch(NumberFormatException ex)
                {
                    throw new org.omg.CORBA.INITIALIZE("udp: invalid " +
                                                       "argument for " +
                                                       "--trace");
                }
                if(trace < 0)
                    trace = 0;

                i += 2;
            }
            else
            {
                throw new org.omg.CORBA.INITIALIZE("udp: unknown server " +
                                                   "parameter `" + params[i] +
                                                   "'");
            }
        }

        try
        {
            org.omg.CORBA.Object obj =
                orb_.resolve_initial_references("OCIAccFactoryRegistry");
            com.ooc.OCI.AccFactoryRegistry registry =
                com.ooc.OCI.AccFactoryRegistryHelper.narrow(obj);
            com.ooc.OB.Logger logger = ((com.ooc.CORBA.ORB)orb_).logger();
            registry.add_factory(new AccFactory_impl(trace, logger));
        }
        catch(org.omg.CORBA.ORBPackage.InvalidName ex)
        {
            com.ooc.OB.Assert._OB_assert(false);
        }
        catch(com.ooc.OCI.FactoryAlreadyExists ex)
        {
            throw new org.omg.CORBA.INITIALIZE("udp: plug-in already " +
                                               "installed");
        }
    }

    // ------------------------------------------------------------------
    // ORBacus internal functions
    // Application programs must not use these functions directly
    // ------------------------------------------------------------------

    public
    Plugin_impl(org.omg.CORBA.ORB orb)
    {
        orb_ = orb;
    }
}
